--[[
do

local OldDefaultProjectileWeapon = DefaultProjectileWeapon
DefaultProjectileWeapon = Class(OldDefaultProjectileWeapon) {
    
    OnWeaponFired = function(self)
        local bp = self:GetBlueprint()
        if self.unit.HasNinjaUpgrade and self.unit.HasNinjaUpgrade == true then
            if self.unit.RecloakCountdown < (bp.UpgradedRecloakAfterFiringDelay or 0) then
                self.unit.RecloakCountdown = bp.UpgradedRecloakAfterFiringDelay or 0
            end
        else
            if self.unit.RecloakCountdown < (bp.RecloakAfterFiringDelay or 0) then
                self.unit.RecloakCountdown = bp.RecloakAfterFiringDelay or 0
            end
        end
        OldDefaultProjectileWeapon.OnWeaponFired(self)
    end,

} TypeClass = DefaultProjectileWeapon

end

do

local OldDefaultBeamWeapon = DefaultBeamWeapon
DefaultBeamWeapon = Class(DefaultBeamWeapon) {

    OnWeaponFired = function(self)
        local bp = self:GetBlueprint()
        if self.unit.HasNinjaUpgrade and self.unit.HasNinjaUpgrade == true then
            if self.unit.RecloakCountdown < (bp.UpgradedRecloakAfterFiringDelay or 0) then
                self.unit.RecloakCountdown = bp.UpgradedRecloakAfterFiringDelay or 0
            end
        else
            if self.unit.RecloakCountdown < (bp.RecloakAfterFiringDelay or 0) then
                self.unit.RecloakCountdown = bp.RecloakAfterFiringDelay or 0
            end
        end
        OldDefaultBeamWeapon.OnWeaponFired(self)
    end,

} TypeClass = DefaultBeamWeapon

end
--]]

do

local OldDefaultProjectileWeapon = DefaultProjectileWeapon
DefaultProjectileWeapon = Class(OldDefaultProjectileWeapon) {

    OnWeaponFired = function(self)
        OldDefaultProjectileWeapon.OnWeaponFired(self)
        local unitbp = self.unit:GetBlueprint()
        local unit = self.unit


        if unitbp.Air.MatchSpeedToTarget and unitbp.Air and self:GetCurrentTarget() and not self.Thread then
            local targetbp = self:GetCurrentTarget():GetBlueprint()
            if targetbp.Air then
                local fuel = unit:GetFuelRatio() or 0
                #--------------#
                #-Speed Values-#
                #--------------#
                local mySpeed = unitbp.Air.MaxAirspeed
                local targetSpeed = targetbp.Air.MaxAirspeed
                #-------------------------------------#
                #-Percent to use for Speed Multiplier-#
                #-------------------------------------#
    
                ##Default Value
                local speedPercent = 1
                ##-----------------------------------------------------------------------------
                ## This IF block ensures that a plane can never go BELOW its minimum speed when
                ## trying to match its target's speed
                ##-----------------------------------------------------------------------------
    
                if targetSpeed < unitbp.Air.MinAirspeed then
                    speedPercent = unitbp.Air.MinAirspeed/mySpeed
                else
                    speedPercent = targetSpeed/mySpeed
                end
                ##------------------------------------------------------------------------------------------
                ## This IF block ensures that our plane will never go ABOVE its Maximum Speed when chasing a
                ## target ( i.e. when a t1 interceptor is chasing a t3 Air Sup fighter )
                ##------------------------------------------------------------------------------------------
                if speedPercent < 1 and (fuel > 0) then
                    self.unit:SetSpeedMult(speedPercent)
                end
            end
        end
    end,

    OnLostTarget = function(self)
        OldDefaultProjectileWeapon.OnLostTarget(self)
        local me = self.unit
        local unitbp = self.unit:GetBlueprint()
        local unit = self.unit


        #Make sure this weapon is on a unit that should match speed.
        if unitbp.Air.MatchSpeedToTarget then
            local fuel = unit:GetFuelRatio() or 0
            ##------------------------------------------------------------------------------
            ## waitnow() - This function first waits 1 Second after the kill, 
            ##             then reverts the plane back to default speed if its still alive
            ##------------------------------------------------------------------------------
            waitnow = function(self)
                WaitSeconds(1)
                if not me:IsDead() and not me.Thread and (fuel > 0) then
                    me:SetSpeedMult(1)
                end
            end
            ##----------------------------
            ## Execute waitnow() Function
            ##----------------------------
            me:ForkThread(waitnow)
        end
    end,
} TypeClass = DefaultProjectileWeapon

end
