do

local oldModBlueprints = ModBlueprints

function ModBlueprints(all_bps)
    oldModBlueprints(all_bps)


--                                                                                         
--                                     TAG REMOVAL                                         
--                                                                                         


    all_bps.Unit["uel0303"].Defense.Shield = {}                                         -- UEF Titan
    all_bps.Unit["uel0401"].Defense.Shield = {}                                         -- UEF Ogre
    all_bps.Unit["uel0001"].Enhancements.HeavyAntiMatterCannon.ShowBones = {}           -- UEF ACU
    all_bps.Unit["url0001"].Enhancements.MicrowaveLaserGenerator.HideBones = {}         -- Cybran ACU
    all_bps.Unit["url0001"].Enhancements.MicrowaveLaserGeneratorRemove.ShowBones = {}   -- Cybran ACU
    all_bps.Unit["url0001"].Enhancements.StealthGenerator.Prerequisite = nil            -- Cybran ACU
    all_bps.Unit["url0301"].Enhancements.StealthGenerator.Prerequisite = nil            -- Cybran CE


--                                                                                         
--                                     WEAPONS                                             
--                                                                                         


    all_bps.Unit["ueb2304"].Weapon[1].RackBones =                                       -- UEF T3 AA
        {
            {
                MuzzleBones = {
                    'Turret_Muzzle_Left01',
                },
                RackBone = 'Turret_Barrel',
            },
            {
                MuzzleBones = {
                    'Turret_Muzzle_Right01',
                },
                RackBone = 'Turret_Barrel',
            },
        }

    all_bps.Unit["urb2304"].Weapon[1].RackBones =                                       -- Cybran T3 AA
        {
            {
                MuzzleBones = {
                    'Turret_Left_Muzzle01',
                },
                RackBone = 'Turret_Left_Muzzle01',
            },
            {
                MuzzleBones = {
                    'Turret_Right_Muzzle01',
                },
                RackBone = 'Turret_Right_Muzzle01',
            },
        }


--                                                                                         
--                                 MASS UNIT MODIFICATIONS                                 
--                                                                                         

    for id,bp in pairs(all_bps.Unit) do

        # GET UNIT'S CATEGORIES

        local cats = {}
        for k,cat in pairs(bp.Categories) do
            cats[cat] = true
        end


        # Veterancy Adjustment
        # 
        # This brings unit veterancy to an attainable level.
        # This also adds a rough DPS value to each tech level.

        if bp.Veteran then
            #Standardize levels. Level value = # of seconds in combat
            bp.Veteran = { Level1 = 10, Level2 = 30, Level3 = 60, Level4 = 100, Level5 = 200 }

            if not bp.dps then
                bp.dps = 1                                          -- This makes anything not covered by a category go Vet5 immediately, to be obvious.
                if cats.COMMAND then                                -- ACU
                    bp.dps = 500
                elseif cats.SUBCOMMANDER then                       -- Combat Engineers
                    bp.dps = 150
                elseif cats.TECH1 then
                    if cats.LAND then
                        if cats.INTELLIGENCE then                   -- Land Scouts
                            bp.dps = 0.5
                        elseif cats.DIRECTFIRE then                 -- LAB / Light Tanks
                            bp.dps = 25
                        elseif cats.ARTILLERY then                  -- Light Mobile Artillery
                            bp.dps = 85
                        elseif cats.ANTIAIR then                    -- Light Mobile AA
                            bp.dps = 10
                        end
                    elseif cats.NAVAL then
                        if cats.DIRECTFIRE then                     -- Frigates
                            bp.dps = 100
                        elseif cats.SUBMERSIBLE then                -- Subs
                            bp.dps = 150
                        end
                    elseif cats.AIR then
                        if cats.ANTIAIR then                        -- Interceptors
                            bp.dps = 15
                        elseif cats.BOMBER then                     -- Light Bombers
                            bp.dps = 90
                        end
                    elseif cats.STRUCTURE then
                        if cats.ANTIAIR then                        -- Light AA Turret
                            bp.dps = 75
                        elseif cats.DIRECTFIRE then                 -- Point Defense
                            bp.dps = 75
                        elseif cats.ANTINAVY then                   -- Light Torpedo Launcher
                            bp.dps = 300
                        end
                    end
                elseif cats.TECH2 then
                    if cats.LAND then
                        if cats.DAMAGEGIVER then                    -- Damage Givers
                            bp.dps = 250
                        elseif cats.DIRECTFIRE then                 -- Heavy Tanks
                            bp.dps = 100
                        elseif cats.INDIRECTFIRE then               -- Mobile Missile Launchers
                            bp.dps = 130
                        elseif cats.ANTIAIR then                    -- Mobile Flak
                            bp.dps = 200
                        end
                    elseif cats.NAVAL then
                        if cats.DIRECTFIRE then                     -- Destroyers
                            bp.dps = 400
                        elseif cats.ANTIAIR then                    -- Cruisers
                            bp.dps = 250
                        end
                    elseif cats.AIR then
                        if cats.ANTINAVY then                       -- Torpedo Bombers
                            bp.dps = 120
                        elseif cats.BOMBER then                     -- Heavy Bombers
                            bp.dps = 250
                        elseif cats.GROUNDATTACK then               -- Gunships
                            bp.dps = 100
                        elseif cats.TRANSPORTATION then             -- Transports
                            bp.dps = 50
                        end
                    elseif cats.STRUCTURE then
                        if cats.ANTIAIR then                        -- Flak Turrets
                            bp.dps = 250
                        elseif cats.DIRECTFIRE then                 -- Advanced Point Defense
                            bp.dps = 200
                        elseif cats.ANTINAVY then                   -- Heavy Torpedo Launchers
                            bp.dps = 1200
                        elseif cats.ARTILLERY then                  -- Artillery Installations
                            bp.dps = 600
                        elseif cats.TACTICALMISSILEPLATFORM then    -- Tactical Missile Launchers
                            bp.dps = 800
                        end
                    end
                elseif cats.TECH3 then
                    if cats.LAND then
                        if cats.DIRECTFIRE then                     -- Special Assault Bots
                            bp.dps = 200
                        elseif cats.ARTILLERY then                  -- Heavy Mobile Artillery
                            bp.dps = 300
                        end
                    elseif cats.NAVAL then
                        if cats.DIRECTFIRE then                     -- Battleships
                            bp.dps = 600
                        elseif cats.CARRIER then                    -- Aircraft Carriers
                            bp.dps = 300
                        elseif cats.SUBMERSIBLE then                -- Nuke Subs
                            bp.dps = 5000
                        end
                    elseif cats.AIR then
                        if cats.BOMBER then                         -- Strategic Bombers
                            bp.dps = 1000
                        elseif cats.ANTIAIR then                    -- Air Superiority Fighters
                            bp.dps = 100
                        elseif cats.GROUNDATTACK then               -- UEF Broadsword
                            bp.dps = 300
                        end
                    elseif cats.STRUCTURE then
                        if cats.ANTIAIR then                        -- Advanced AA Missile Launchers
                            bp.dps = 600
                        elseif cats.NUKE then                       -- Nuke Launchers
                            bp.dps = 5000
                        elseif cats.ARTILLERY then                  -- Heavy Artillery Installations
                            bp.dps = 1000
                        end
                    end
                end
            end
        end

    # New Veterancy Buffs
    #
    # This will remove ALL of the previous buffs, and then we will implement a completely new system
    
    if bp.Buffs then
        bp.Buffs = nil
    end
    if bp.Weapon then
        for k,v in pairs(bp.Weapon) do
            if v.Buffs then
                if v.Label != 'DeathWeapon' then
                    v.Buffs = nil
                end
            end
        end
    end

    # New Buff system
    #
    # The idea behind the new buffs is that it emphasises realistic skill improvement of a unit, rather
    # than unrealistic things like extra health for no reason, more projectile damage, etc.
    # We may move to a 3-tier system at a later point, but for now it will be 5 as per standard supcom.
    # Each level, the unit recieves bonuses to weapons and chassis. We will try to stay away from non-visible
    # upgrades to a unit, like projectile damage.

    # Currently Available options:
    # FIRINGRANDOMNESS
    # MAXRADIUS
    # DAMAGE
    # TURRETYAWSPEED
    # TURRETPITCHSPEED
    # RATEOFFIRE

    # HEALTHREGENRATE
    # FUELRATIO
    # MAXFUEL
    # SPEEDMULT
    # HEALTH
    # MAXHEALTH

    # To be implemented at a later date:
    # ACCELERATION
    # MINAIRSPEED
    # MAXAIRSPEED

    # Unit Buffs
    # Top Speed and Regenrate
    bp.Buffs = {
        # Top Speed
        {
            Add = {
                VeteranLevel1 = true,
            },
            BuffType = 'SPEEDMULT',
            Value = 1.1,
        },
        {
            Add = {
                VeteranLevel2 = true,
            },
            BuffType = 'SPEEDMULT',
            Value = 1.2,
        },
        {
            Add = {
                VeteranLevel3 = true,
            },
            BuffType = 'SPEEDMULT',
            Value = 1.3,
        },
        {
            Add = {
                VeteranLevel4 = true,
            },
            BuffType = 'SPEEDMULT',
            Value = 1.4,
        },
        {
            Add = {
                VeteranLevel5 = true,
            },
            BuffType = 'SPEEDMULT',
            Value = 1.5,
        },
        # Fuel
        {
            Add = {
                VeteranLevel1 = true,
            },
            BuffType = 'MAXFUEL',
            Value = bp.Physics.FuelUseTime or 0 * 1.1,
        },
        {
            Add = {
                VeteranLevel2 = true,
            },
            BuffType = 'MAXFUEL',
            Value = bp.Physics.FuelUseTime or 0 * 1.2,
        },
        {
            Add = {
                VeteranLevel3 = true,
            },
            BuffType = 'MAXFUEL',
            Value = bp.Physics.FuelUseTime or 0 * 1.3,
        },
        {
            Add = {
                VeteranLevel4 = true,
            },
            BuffType = 'MAXFUEL',
            Value = bp.Physics.FuelUseTime or 0 * 1.4,
        },
        {
            Add = {
                VeteranLevel5 = true,
            },
            BuffType = 'MAXFUEL',
            Value = bp.Physics.FuelUseTime or 0 * 1.5,
        },
        #Regen      NOTE: Each Regen value is ADDED to the unit, not REPLACING what it already has!!!
        {
            Add = {
                VeteranLevel4 = true,
            },
            BuffType = 'HEALTHREGENRATE',
            Value = (bp.Defense.RegenRate or 0) + ((bp.Defense.MaxHealth or 0) / 100 * 0.5),
        },
        {
            Add = {
                VeteranLevel5 = true,
            },
            BuffType = 'HEALTHREGENRATE',
            Value = (bp.Defense.RegenRate or 0) + ((bp.Defense.MaxHealth or 0) / 100 * 1),  -- Adds up to 1.5 now including Vet4's 0.5
        },
    }

    # Weapon Buffs
    #
    # ROF, Turret Speed, MaxRadius


    if bp.Weapon then
        for k,v in pairs(bp.Weapon) do
            if v.Label != 'DeathWeapon' then
                if not cats.COMMAND then
                    v.Buffs = {
                        # ROF
                        {
                            Add = {
                                VeteranLevel1 = true,
                            },
                            BuffType = 'RATEOFFIRE',
                            Value = (v.RateOfFire or 0)* 1.05,
                        },
                        {
                            Add = {
                                VeteranLevel2 = true,
                            },
                            BuffType = 'RATEOFFIRE',
                            Value = (v.RateOfFire or 0) * 1.2,
                        },
                        {
                            Add = {
                                VeteranLevel3 = true,
                            },
                            BuffType = 'RATEOFFIRE',
                            Value = (v.RateOfFire or 0) * 1.4,
                        },
                        {
                            Add = {
                                VeteranLevel4 = true,
                            },
                            BuffType = 'RATEOFFIRE',
                            Value = (v.RateOfFire or 0) * 1.5,
                        },
                        {
                            Add = {
                                VeteranLevel5 = true,
                            },
                            BuffType = 'RATEOFFIRE',
                            Value = (v.RateOfFire or 0) * 2,
                        },

                        # Turret Speed
                        {
                            Add = {
                                VeteranLevel1 = true,
                            },
                            BuffType = 'TURRETYAWSPEED',
                            Value = (v.TurretYawSpeed or 0) * 1.05,
                        },
                        {
                            Add = {
                                VeteranLevel2 = true,
                            },
                            BuffType = 'TURRETYAWSPEED',
                            Value = (v.TurretYawSpeed or 0) * 1.25,
                        },
                        {
                            Add = {
                                VeteranLevel3 = true,
                            },
                            BuffType = 'TURRETYAWSPEED',
                            Value = (v.TurretYawSpeed or 0) * 1.4,
                        },
                        {
                            Add = {
                                VeteranLevel4 = true,
                            },
                            BuffType = 'TURRETYAWSPEED',
                            Value = (v.TurretYawSpeed or 0) * 1.5,
                        },
                        {
                            Add = {
                                VeteranLevel5 = true,
                            },
                            BuffType = 'TURRETYAWSPEED',
                            Value = (v.TurretYawSpeed or 0) * 2,
                        },

                        #Range
                        {
                            Add = {
                                VeteranLevel3 = true,
                            },
                            BuffType = 'MAXRADIUS',
                            Value = (v.MaxRadius or 0) * 1.05,
                        },
                        {
                            Add = {
                                VeteranLevel5 = true,
                            },
                            BuffType = 'MAXRADIUS',
                            Value = (v.MaxRadius or 0) * 1.15,
                        },
                    }
                end
            end
        end
    end



    # Future Hopes:
    #
    # Level 1
    # Firing accuracy increased 10%
    # ROF increased 5%
    # Acceleration increased 10%
    # Fuel Usage Reduced 10%

    # Level 2
    # Firing accuracy increased 25%
    # ROF increased 20%                 -
    # Acceleration increased 20%
    # Turn rate increased 15%
    # Top Speed increased 10%

    # Level 3
    # Firing accuracy increased 40%
    # ROF increased 40%
    # Range increased 5%
    # Acceleration increased 25%
    # Turn rate increased 20%
    # Top Speed increased 20%

    # Level 4
    # Firing accuracy increased 40%
    # ROF increased 50%
    # Range increased 5%
    # Acceleration increased 25%
    # Turn rate increased 30%
    # Top Speed increased 30%
    # Regenrate 1%

    # Level 5
    # Firing accuracy increased 100%
    # ROF increased 100%
    # Range increased 15%
    # Acceleration increased 50%
    # Turn rate increased 50%
    # Top Speed increased 50%
    # Regenerate Rate 5%



    # Ship Wreckage
    # 
    # Part of the alteration which allows ship wreckage to stay on the seabed.

        if cats.NAVAL then
            if not bp.Wreckage then
                LOG("Adding wreckage information to ", bp.Description)
                bp.Wreckage = {
                    Blueprint = '/props/DefaultWreckage/DefaultWreckage_prop.bp',
                    EnergyMult = 0,
                    HealthMult = 0.9,
                    MassMult = 0.9,
                    ReclaimTimeMultiplier = 1,
                    WreckageLayers = {
                        Air = false,
                        Land = false,
                        Seabed = true,
                        Sub = true,
                        Water = true,
                    };
                }
            else
                LOG("Updating WreckageLayers for ", bp.Description)
                local wl = bp.Wreckage.WreckageLayers
                wl.Seabed = true
                wl.Sub = true
                wl.Water = true
            end
        end


    # Free Regen
    #
    # A small amount of regen has been added to simulate field repairs on units.
    # It should have no impact on battle outcomes, but units just sitting around a long time will eventually repair.
        local MinimumRegenRate = math.max(2,math.min(bp.Defense.MaxHealth * .002,50))
        if bp.Defense.RegenRate < MinimumRegenRate then
            bp.Defense.RegenRate = MinimumRegenRate
        end


    # Escalation Slowdown
    #
    # This change makes the build times of all factory-built units go along with the new faster factory build rates.
    # The purpose of the factory adjustment was to bring factories in general a step above engineers in terms of build
    # rate, so that engineer assistance would not have such a major impact on how fast factories produce units.
        if cats.MOBILE then
            if bp.Economy.BuildTime then
                if cats.ENGINEER then
                else
                    if cats.EXPERIMENTAL then
                    else
                        if cats.TECH1 then
                            bp.Economy.BuildTime = bp.Economy.BuildTime * 4     -- T1 Factory built units except engineers
                        elseif cats.TECH2 then
                            bp.Economy.BuildTime = bp.Economy.BuildTime * 3     -- T2 Factory built units except engineers
                        elseif cats.TECH3 then
                            bp.Economy.BuildTime = bp.Economy.BuildTime * 2     -- T3 Factory built units except engineers
                        end
                    end
                end
            end
        end


    # Resource Storage Reassignment
    # 
    # Make storage in ACU and designated storage structures ONLY.

        if not (cats.MASSSTORAGE or cats.ENERGYSTORAGE or cats.COMMAND) then
            if bp.Economy.StorageEnergy then
                bp.Economy.StorageEnergy = 0
            end
            if bp.Economy.StorageMass then
                bp.Economy.StorageMass = 0
            end
        end


    # Ship Speed
    # 
    # Make ships and subs in general slower.

        if cats.NAVAL and cats.MOBILE then  
            if bp.Physics.MaxAcceleration and bp.Physics.MaxSpeed and bp.Physics.MaxBrake then
                if cats.SUBMERSIBLE then

                    -- Be careful with subs - they appear to surface/dive much slower if you reduce their acceleration and/or speed.

                    if cats.TECH1 then
                        bp.Physics.MaxSpeed = bp.Physics.MaxSpeed * .5
                        bp.Physics.MaxBrake = bp.Physics.MaxBrake * .2
                    elseif cats.EXPERIMENTAL then
                        bp.Physics.MaxSpeed = bp.Physics.MaxSpeed * .5 -- Tempest and Atlantis - how's their speed?
                        bp.Physics.MaxBrake = bp.Physics.MaxBrake * .2
                    end

                else
                    bp.Physics.MaxSpeed = bp.Physics.MaxSpeed * .25
                    bp.Physics.MaxBrake = bp.Physics.MaxBrake * .1
                end
            end
        end


    # Ship Sink Speed
    # 
    # Make ships sink slower.

        if cats.NAVAL and cats.MOBILE then  
            if bp.Display.AnimationDeath then
                for k,Anim in pairs(bp.Display.AnimationDeath) do
                    if cats.TECH1 then
                        bp.Display.AnimationDeath[k].AnimationRateMax = 0.9
                        bp.Display.AnimationDeath[k].AnimationRateMin = 0.6
                    elseif cats.TECH2 then
                        bp.Display.AnimationDeath[k].AnimationRateMax = 0.6
                        bp.Display.AnimationDeath[k].AnimationRateMin = 0.3
                    elseif cats.TECH3 then
                        bp.Display.AnimationDeath[k].AnimationRateMax = 0.3
                        bp.Display.AnimationDeath[k].AnimationRateMin = 0.2
                    end
                end
            end
        end


    # Sonar Stealth for small ships when not moving
    # 
        --[[
        if cats.NAVAL and cats.MOBILE then  
            if not cats.SUBMERSIBLE then
                if cats.TECH1 or cats.TECH2 then
                    bp.Intel.SonarStealth = true
                end
            end
        end
        --]]

        --[[
        if bp.Physics.BuildOnLayerCaps.LAYER_Seabed then
            if bp.Physics.BuildOnLayerCaps.LAYER_Water == true then
            else
                if not bp.Intel then
                    bp.Intel = {}
                end
                bp.Intel.SonarStealth = true                                -- Floating structures
            end
        end
        --]]

    # Aircraft Fuel
    # 
    # Make planes run out of fuel at specific rates relative to original game

        local FuelMultiplier = 1
        if cats.AIR then
            if cats.ANTIAIR and (cats.TECH1 or cats.TECH3) then  # Excludes T2 gunships which are AA
                FuelMultiplier = .5
            elseif cats.BOMBER then
                FuelMultiplier = .3
            elseif cats.TRANSPORTATION and not cats.GROUNDATTACK then
                FuelMultiplier = 2
            elseif cats.GROUNDATTACK and (cats.TECH2 or cats.TECH3) then  # Excludes Experimental gunships
                FuelMultiplier = .3
            elseif cats.ANTINAVY then
                FuelMultiplier = .3
            elseif cats.EXPERIMENTAL then
                FuelMultiplier = 10
            end
            if not cats.EXPERIMENTAL and not cats.TRANSPORTATION then
                bp.Physics.FuelRechargeRate = 3  #  May make this zero - free gas for non-experimentals is silly.
            end
            if cats.TRANSPORTATION and not cats.GROUNDATTACK then
                if cats.TECH1 then
                    bp.Defense.RegenRate = 10
                elseif cats.TECH2 then
                    bp.Defense.RegenRate = 25
                end
            end
            if bp.Physics.FuelUseTime then
                bp.Physics.FuelUseTime = bp.Physics.FuelUseTime * FuelMultiplier
            end
        end


    # Aircraft Armor
    # 
    # Multiply all aircraft armor and AA weapon damage by 10.
    # This has no effect on the AA vs Aircraft balance, but brings the armor and hit counts closer to the rest of the game units.

        if cats.AIR and cats.MOBILE then
            if bp.Defense.Health then
                bp.Defense.Health = bp.Defense.Health * 10
            end
            if bp.Defense.MaxHealth then
                bp.Defense.MaxHealth = bp.Defense.MaxHealth * 10
            end
        end
        if bp.Weapon then
            for k,v in pairs(bp.Weapon) do
                local AntiTac = false
                local AAWeapon = false
                if v.FireTargetLayerCapsTable then
                    --if (not v.TargetRestrictOnlyAllow) or (not v.TargetRestrictOnlyAllow == 'TACTICAL MISSILE') then
                    if v.TargetRestrictOnlyAllow then
                        if v.TargetRestrictOnlyAllow == 'TACTICAL MISSILE' then
                            AntiTac = true
                        end
                    end
                    --if (TargetRestrictOnlyAllow = 'AIR') or (not v.TargetRestrictOnlyAllow) or (not v.TargetRestrictOnlyAllow == 'TACTICAL MISSILE') then
                    if AntiTac == false then
                        for k2,v2 in pairs(v.FireTargetLayerCapsTable) do
                            if v2 == ('Air' or 'Air|Land') then
                                AAWeapon = true
                                break
                            end
                        end
                    end
                end
                if AAWeapon == true then
                    if v.Damage then
                        v.Damage = v.Damage * 10
                    end
                    if cats.TECH1 then
                        v.DamageType = "T1AA"
                    end
                end
            end
        end
        if cats.AIRSTAGINGPLATFORM then
            bp.AI.RefuelingRepairAmount = 100
        end



    # Expanded Tarmacs      **Reverted**
    # 
    # Make UEF and Cybran tarmacs bigger.

--        if cats.UEF or cats.CYBRAN then
        if cats.UEF then
            if bp.Display.Tarmacs then
                bp.Display.Tarmacs[1].Length = bp.Display.Tarmacs[1].Length * 2
                bp.Display.Tarmacs[1].Width = bp.Display.Tarmacs[1].Width * 2
                bp.Display.Tarmacs[1].FadeOut = 900
            end
        end

    # Nix Omni
    # 
    # Removes Omni from the game.

        if bp.Intel.OmniRadius then
            bp.Intel.OmniRadius = 0
        end


    # Sonar Ping
    # 
    # Defines nature of the sonar ping
    # For non-fading decay (instant ping off) set SonarDecaySteps to 1
    # To disable, set any of these parameters to nil

--[[
        if bp.Intel.SonarRadius and bp.Intel.VisionRadius then
            bp.Intel.SonarDecayStepSize = 6
            bp.Intel.SonarDecayStepDuration = 0.1
            bp.Intel.SonarPauseAfterDecay = 7.5
        end
--]]



    # Upgrade Build Times
    # 
    # This is an attempt to standardize the rate which resources are consumed for ACU/SCU upgrades.
    # The factors may be adjusted as necessary to taste upon playtesting.
    # Mass =     0-500:     10 mass/sec
    # Mass =   500-2000:    25 mass/sec
    # Mass =  2000-25000:   50 mass/sec
    # Mass = 25000 and up: 250 mass/sec

        if bp.Enhancements then
            for EnhancementName,ThisEnhancement in pairs(bp.Enhancements) do
                if bp.Enhancements[EnhancementName].BuildCostMass then
                    if bp.Enhancements[EnhancementName].BuildCostMass <= 2 then
                        bp.Enhancements[EnhancementName].BuildTime = 0.1              -- For Enhancement Removals
                    elseif bp.Enhancements[EnhancementName].BuildCostMass <= 500 then
                        bp.Enhancements[EnhancementName].BuildTime = bp.Enhancements[EnhancementName].BuildCostMass / .333333
                    elseif bp.Enhancements[EnhancementName].BuildCostMass <= 2000 then
                        bp.Enhancements[EnhancementName].BuildTime = bp.Enhancements[EnhancementName].BuildCostMass / .833333
                    elseif bp.Enhancements[EnhancementName].BuildCostMass >= 25000 then
                        bp.Enhancements[EnhancementName].BuildTime = bp.Enhancements[EnhancementName].BuildCostMass / 8.333333
                    else
                        bp.Enhancements[EnhancementName].BuildTime = bp.Enhancements[EnhancementName].BuildCostMass / 1.666667
                    end
                end
            end
        end



    # Node Teleport Enabling
    # This gives teleporting to ALL units in the game but does not enable the actual teleport button.
    # It only sets up the cost for teleporting, and the recharge delay.
    # It only does this for units which are not already set up for teleporting.
        if cats.MOBILE then
            local NaturalTeleporter = false
            if bp.General.CommandCaps.RULEUCC_Teleport then
                if bp.General.CommandCaps.RULEUCC_Teleport == true then
                    NaturalTeleporter = true
                    bp.Physics.NaturalTeleporter = true
                end
            end
            if NaturalTeleporter == false then
                bp.Physics.NaturalTeleporter = false
            end
            bp.Economy.TeleportMassMod = 0
            bp.Economy.TeleportTimeMod = 0
            if cats.NAVAL then
                if cats.EXPERIMENTAL or cats.TECH3 then
                    bp.Economy.TeleportEnergyMod = 25000 / bp.Economy.BuildCostEnergy
                    bp.Physics.TeleportRechargeTime = 300
                elseif cats.TECH2 then
                    bp.Economy.TeleportEnergyMod = 5000 / bp.Economy.BuildCostEnergy
                    bp.Physics.TeleportRechargeTime = 60
                elseif cats.TECH1 then
                    bp.Economy.TeleportEnergyMod = 1000 / bp.Economy.BuildCostEnergy
                    bp.Physics.TeleportRechargeTime = 60
                end
            else
                if cats.COMMAND then
                    bp.Economy.TeleportEnergyMod = 15000 / bp.Economy.BuildCostEnergy
                    bp.Physics.TeleportRechargeTime = 60
                elseif cats.SUBCOMMANDER then
                    bp.Economy.TeleportEnergyMod = 5000 / bp.Economy.BuildCostEnergy
                    bp.Physics.TeleportRechargeTime = 5
                elseif cats.EXPERIMENTAL then
                    bp.Economy.TeleportEnergyMod = 25000 / bp.Economy.BuildCostEnergy
                    bp.Physics.TeleportRechargeTime = 300
                elseif cats.TECH3 then
                    if bp.BlueprintId == "ual0303" then
                        bp.Economy.TeleportEnergyMod = 1000 / bp.Economy.BuildCostEnergy
                        bp.Physics.TeleportRechargeTime = 60
                    else
                        bp.Economy.TeleportEnergyMod = 5000 / bp.Economy.BuildCostEnergy
                        bp.Physics.TeleportRechargeTime = 60
                    end
                elseif cats.TECH2 then
                    bp.Economy.TeleportEnergyMod = 1000 / bp.Economy.BuildCostEnergy
                    bp.Physics.TeleportRechargeTime = 60
                elseif cats.TECH1 then
                    bp.Economy.TeleportEnergyMod = 200 / bp.Economy.BuildCostEnergy
                    bp.Physics.TeleportRechargeTime = 15
                end
            end
        end


    # Cloak Mesh enabling


        local meshid = bp.Display.MeshBlueprint
        if meshid then
            local meshbp = original_blueprints.Mesh[meshid]
            if meshbp then
                local shadername = 'UnitFormationPreview'
                local cloakmeshbp = table.deepcopy(meshbp)
                if cloakmeshbp.LODs then
                    for i,lod in cloakmeshbp.LODs do
                        lod.ShaderName = shadername
                    end
                end
                cloakmeshbp.BlueprintId = meshid .. '_cloak'
                bp.Display.CloakMeshBlueprint = cloakmeshbp.BlueprintId
                MeshBlueprint(cloakmeshbp)
            end
        end


    # Shield Range Rings
        if cats.SHIELD and cats.STRUCTURE then
            if bp.Defense.Shield.ShieldSize then
                if not bp.AI then
                    bp.AI = {}
                end
                bp.AI.GuardScanRadius = bp.Defense.Shield.ShieldSize / 2
                bp.AI.ShowAssistRangeOnSelect = true
            end
        end

    # High Tech Factory Direct Build
    # Allows T2 and T3 factories to be built directly by the appropriate engineers.
--[[
        if cats.FACTORY and cats.STRUCTURE then
            if cats.TECH2 then
                --table.insert(bp.Categories,'BUILTBYTIER1ENGINEER')
                table.insert(bp.Categories,'BUILTBYTIER2ENGINEER')
                table.insert(bp.Categories,'BUILTBYTIER3ENGINEER')
                table.insert(bp.Categories,'BUILTBYTIER2COMMANDER')
                table.insert(bp.Categories,'BUILTBYTIER3COMMANDER')
            end
            if cats.TECH3 then
                --table.insert(bp.Categories,'BUILTBYTIER2ENGINEER')
                --table.insert(bp.Categories,'BUILTBYTIER2COMMANDER')
                table.insert(bp.Categories,'BUILTBYTIER3ENGINEER')
                table.insert(bp.Categories,'BUILTBYTIER3COMMANDER')
            end
        end
--]]


--[[                                -- This project is on hold.

    # Wreckage Mass & Speed
    # 
    # Sets wreckage to be 75% of the mass of the original unit.
    # Makes wreckage reclaim 2x slower than unmodded game.

    if bp.Wreckage then
        bp.Wreckage.MassMult = 0.75
        bp.Wreckage.ReclaimTimeMultiplier = 2
    end

--]]

    # ArmorType Definitions
    # 
    # Sets up the custom armor definitions we use.

        if cats.BOMBER then
            bp.Defense.ArmorType = 'Bomber'
        end
        if cats.GROUNDATTACK and not cats.EXPERIMENTAL then
            bp.Defense.ArmorType = 'Gunship'
        end
        if cats.INTELLIGENCE and cats.AIR then
            bp.Defense.ArmorType = 'Scout'
        end
        
--[[                                -- This project is on hold.
        if cats.NAVAL and cats.MOBILE then
            if bp.Defense.ArmorType then
                bp.Defense.ArmorType = 'ShipHull'
            end
        end
--]]


    # DamageType Definitions
    # 
    # Sets up the custom damage definitions we use.

        if cats.ANTIAIR and cats.TECH2 then
            if cats.STRUCTURE or cats.LAND then
                for i,ThisWeapon in pairs(bp.Weapon) do
                    if ThisWeapon.DetonatesAtTargetHeight and ThisWeapon.DetonatesAtTargetHeight == true then
                        ThisWeapon.DamageType = 'Flak'
                    end
                end
            end
        end

--[[                                -- This project is on hold.
        if bp.Weapon then
            if bp.Description == '<LOC urb2108_desc>Tactical Missile Launcher' then
                local BreakHere = 0
            end
            local LongestRangeWeapon = {}
            for i,ThisWeapon in pairs(bp.Weapon) do
                if (not LongestRangeWeapon) and ThisWeapon.MaxRadius then
                    LongestRangeWeapon = ThisWeapon
                else
                    if ThisWeapon.MaxRadius then
                        if ThisWeapon.MaxRadius > LongestRangeWeapon.MaxRadius then
                            LongestRangeWeapon = ThisWeapon                            -- this is never getting set.
                        end
                    end
                end
            end
            if LongestRangeWeapon then
                if cats.ARTILLERY and cats.STRUCTURE then
                    LongestRangeWeapon.DamageType = 'Artillery'
                end
                if cats.TACTICALMISSILEPLATFORM and cats.STRUCTURE then
                    LongestRangeWeapon.DamageType = 'TacticalMissile'
                end
                if cats.NUKE or (cats.COMMAND and cats.UEF) then
                    LongestRangeWeapon.DamageType = 'Nuke'
                end
                if cats.NAVAL and cats.MOBILE then
                    LongestRangeWeapon.DamageType = 'NavalWeapon'
                end
            end
        end
--]]




    # Adjust the storage in the ACUs so the initial resources match increased costs due to Escalation Slowdown.

        if cats.COMMAND then
            bp.Economy.StorageMass = 600
            bp.Economy.StorageEnergy = 3500
        end


    end     -- End of unit loop


--                                                                                         
--                                     PROJECTILES                                         
--                                                                                         

    for id,bp in pairs(all_bps.Projectile) do 
        -- Cybran Tactical Missile
        local a,b = string.find(string.upper(bp.BlueprintId),'CIFMISSILETACTICAL03')
        if a then
            bp.Economy.BuildCostMass = 120
            bp.Economy.BuildCostEnergy = 2400
            bp.Economy.BuildTime = 15
        end
        -- Aeon Mobile Missile Launcher (Evensong)
        local a,b = string.find(string.upper(bp.BlueprintId),'AIFMISSILESERPENTINE01')
        if a then
            bp.Defense.Health = 4
            bp.Defense.MaxHealth = 4
        end
        -- UEF Mobile Missile Launcher (Flapjack)
        local a,b = string.find(string.upper(bp.BlueprintId),'TIFMISSILECRUISE03')
        if a then
            bp.Defense.Health = 5
            bp.Defense.MaxHealth = 5
        end
        -- Cybran T1 AA missile
        local a,b = string.find(string.upper(bp.BlueprintId),'CAANANODART02')
        if a then
            bp.Physics.MaxSpeed = 45
        end
        -- UEF Torpedo Bomber
        local a,b = string.find(string.upper(bp.BlueprintId),'TANANGLERTORPEDO01')
        if a then
            bp.Physics.MaxSpeed = 10
        end
        -- Modify projectile scripts for "tactical" nuclear weapons.
        local a,z = string.find(string.upper(bp.BlueprintId),'AIFQUANTUMWARHEAD03')
        local b,z = string.find(string.upper(bp.BlueprintId),'CIFEMPFLUXWARHEAD04')
        local c,z = string.find(string.upper(bp.BlueprintId),'TIFMISSILENUKE02')
        local d,z = string.find(string.upper(bp.BlueprintId),'TIFMISSILENUKECDR')
        if a or b or c or d then
            bp.Categories = {
                'AEON',
                'PROJECTILE',
                'INDIRECTFIRE',
                'TACTICAL',
                'MISSILE',
                'NOSPLASHDAMAGE',
            }
            if a then
                table.insert(bp.Categories,'AEON')
            elseif b then
                table.insert(bp.Categories,'CYBRAN')
            else
                table.insert(bp.Categories,'UEF')
            end
            bp.Defense.Health = 35
            bp.Defense.MaxHealth = 35
            bp.DesiredShooterCap = 3
            bp.Economy.BuildCostEnergy = 150000
            bp.Economy.BuildCostMass = 10000
            bp.Economy.BuildTime = 120
            bp.General.EntityCategory = {
                'AEON',
                'PROJECTILE',
                'INDIRECTFIRE',
                'TACTICAL',
                'MISSILE',
                'NOSPLASHDAMAGE',
            }
            if a then
                table.insert(bp.General.EntityCategory,'AEON')
            elseif b then
                table.insert(bp.General.EntityCategory,'CYBRAN')
            else
                table.insert(bp.General.EntityCategory,'UEF')
            end
            bp.Physics.Acceleration = 0.25
            bp.Physics.InitialSpeed = 1
            bp.Physics.MaxSpeed = 10
            bp.Physics.TurnRate = 15
        end
    end

    for id,bp in pairs(all_bps.Prop) do
        if bp.ScriptClass == 'Tree' then
            bp.Display.UniformScale = bp.Display.UniformScale * 1.5
        end
        if bp.Categories then
            local cats = {}
            for k,cat in pairs(bp.Categories) do
                cats[cat] = true
            end
            if cats.RECLAIMABLE then
                if bp.Economy.ReclaimMassMax then
                    bp.Economy.ReclaimMassMax = bp.Economy.ReclaimMassMax * 2   -- Make reclaimable map objects worth 4x as much
                end
            end
        end
    end     -- End of prop loop

end

end