#
# AA Missile for Cybrans
#
local CAAMissileNaniteProjectile = import('/lua/cybranprojectiles.lua').CAAMissileNaniteProjectile
CAAMissileNanite02 = Class(CAAMissileNaniteProjectile) {

    OnCreate = function(self)
        CAAMissileNaniteProjectile.OnCreate(self)
        self:ForkThread(self.UpdateThread)
        self:ForkThread(self.CheckTarget,self)
    end,

    UpdateThread = function(self)
        WaitSeconds(1.5)
        self:SetMaxSpeed(80)
        self:SetAcceleration(10 + Random() * 8)
        self:ChangeMaxZigZag(0.5)
        self:ChangeZigZagFrequency(2)
    end,

    OnImpact = function(self, TargetType, TargetEntity)
        CAAMissileNaniteProjectile.OnImpact(self, TargetType, TargetEntity)
    end,

    CheckTarget = function(self)
        WaitSeconds(0.5)
        local unit = self:GetLauncher()
        while self do
            if not (self:GetTrackingTarget()) then
                #Get New Target
                #LOG("*debug: No Target!!!")
                if unit then
                    local brain = unit:GetAIBrain()
                    #LOG("*debug: Got brain")
                    local units = brain:GetUnitsAroundPoint(categories.AIR, self:GetPosition(),100 , 'Enemy')
                    for k,v in units do
                        #LOG("*debug: Got New Target!")
                        if self:Get2DDistance(v:GetPosition(),unit:GetPosition()) < unit:GetBlueprint().Weapon[1].MaxRadius then
                            self:SetNewTarget(v)
                            break
                        end
                    end
                end
            #else
                #LOG("*debug: Have a target!")
                #LOG("*debug: Target's name is: " ..  self:GetTrackingTarget().GetBlueprint().General.Name)
            end
            WaitSeconds(0.5)
            if self:Get2DDistance(self:GetPosition(),unit:GetPosition()) > unit:GetBlueprint().Weapon[1].MaxRadius + 5 then
                self:Destroy()
            end
        end
    end,

    Get2DDistance = function(self,Pos1,Pos2)
        return VDist2(Pos1[1], Pos1[3], Pos2[1], Pos2[3])
    end,
}

TypeClass = CAAMissileNanite02

