do
local OldProjectile = CIFEMPFluxWarhead04 
CIFEMPFluxWarhead04 = Class(OldProjectile) { 
    OnImpact = function(self, TargetType, TargetEntity)
        if not TargetEntity or not EntityCategoryContains(categories.PROJECTILE, TargetEntity) then
            # Play the explosion sound
            local myBlueprint = self:GetBlueprint()
            if myBlueprint.Audio.Explosion then
                self:PlaySound(myBlueprint.Audio.Explosion)
            end

            nukeProjectile = self:CreateProjectile('/projectiles/CIFEMPFluxWarhead02/CIFEMPFluxWarhead02_proj.bp', 0, 0, 0, nil, nil, nil):SetCollision(false)
            local pos = self:GetPosition()
            --pos[2] = pos[2] + 20
            Warp( nukeProjectile, pos)
            nukeProjectile:PassData(self.Data)
        end
        CEMPFluxWarheadProjectile.OnImpact(self, TargetType, TargetEntity)
    end,
    MovementThread = function(self)
        local army = self:GetArmy()
        local target = self:GetTrackingTarget()
        local launcher = self:GetLauncher()
        self.CreateEffects( self, self.InitialEffects, army, 1 )
        self:TrackTarget(false)
        WaitSeconds(3)
        self:SetCollision(true)
        self.CreateEffects( self, self.LaunchEffects, army, 1 )
        WaitSeconds(3)
        self:SetTurnRate(5)
        self.CreateEffects( self, self.ThrustEffects, army, 3 )
        WaitSeconds(6)
        self:TrackTarget(true)
        self:SetTurnRate(25)
        WaitSeconds(3.5)
        self:SetBallisticAcceleration(10)
        while not self:BeenDestroyed() do
            self:SetTurnRateByDist()
            WaitSeconds(0.5)
        end
    end,
    SetTurnRateByDist = function(self)
        local dist = self:GetDistanceToTarget()
        if dist > 200 and self.MovementTurnLevel < 2 then
            self:SetTurnRate(0)
            self.MovementTurnLevel = 1
        elseif dist > 85 and dist <= 200 and self.MovementTurnLevel < 3 then
            self:SetTurnRate(30)
            self.MovementTurnLevel = 2
        else
            OldProjectile.SetTurnRateByDist(self)
        end
    end,
} 

TypeClass = CIFEMPFluxWarhead04
end
