#
# Terran Anti Air Missile
#
local TMissileAAProjectile = import('/lua/terranprojectiles.lua').TMissileAAProjectile
TAAMissileFlayer01 = Class(TMissileAAProjectile) {
    OnCreate = function(self, inWater)
          TMissileAAProjectile.OnCreate(self,inWater)
          self:ForkThread(self.CheckTarget,self)
    end,
    
    CheckTarget = function(self)
        WaitSeconds(0.5)
        local unit = self:GetLauncher()
        while self do
            if not (self:GetTrackingTarget()) then
                #Get New Target
                #LOG("*debug: No Target!!!")
                if unit then
                    local brain = unit:GetAIBrain()
                    #LOG("*debug: Got brain")
                    local units = brain:GetUnitsAroundPoint(categories.AIR, self:GetPosition(),100 , 'Enemy')
                    for k,v in units do
                        #LOG("*debug: Got New Target!")
                        if self:Get2DDistance(v:GetPosition(),unit:GetPosition()) < unit:GetBlueprint().Weapon[1].MaxRadius then
                            self:SetNewTarget(v)
                            break
                        end
                    end
                end
            #else
                #LOG("*debug: Have a target!")
                #LOG("*debug: Target's name is: " ..  self:GetTrackingTarget().GetBlueprint().General.Name)
            end
            WaitSeconds(0.5)
            if self:Get2DDistance(self:GetPosition(),unit:GetPosition()) > unit:GetBlueprint().Weapon[1].MaxRadius + 5 then
                self:Destroy()
            end
        end
    end,

    Get2DDistance = function(self,Pos1,Pos2)
        return VDist2(Pos1[1], Pos1[3], Pos2[1], Pos2[3])
    end,
}

TypeClass = TAAMissileFlayer01
