#
# Terran Land-Based Cruise Missile
#
local TMissileCruiseProjectile = import('/lua/terranprojectiles.lua').TMissileCruiseProjectile
local EffectTemplate = import('/lua/EffectTemplates.lua')
local SingleBeamProjectile = import('/lua/sim/defaultprojectiles.lua').SingleBeamProjectile

TIFMissileCruise03 = Class(TMissileCruiseProjectile) {

    FxTrails = EffectTemplate.TMissileExhaust01,
    FxTrailOffset = -0.85,
    
    FxAirUnitHitScale = 0.333,
    FxLandHitScale = 0.333,
    FxNoneHitScale = 0.333,
    FxPropHitScale = 0.333,
    FxProjectileHitScale = 0.333,
    FxProjectileUnderWaterHitScale = 0.333,
    FxShieldHitScale = 0.333,
    FxUnderWaterHitScale = 0.333,
    FxUnitHitScale = 0.333,
    FxWaterHitScale = 0.333,
    FxOnKilledScale = 0.333,
    
    OnCreate = function(self)
        TMissileCruiseProjectile.OnCreate(self)
        self:SetCollisionShape('Sphere', 0, 0, 0, 1.2)
        self:ForkThread(self.CruiseMissileThread)
        --self:ForkThread(self.CheckTarget,self)
    end,

    CruiseMissileThread = function(self)
        self:SetTurnRate(20)
        WaitSeconds(2)
        self:SetTurnRate(180)
        WaitSeconds(1)
        self:SetTurnRate(180)
    end,
    
    OnImpact = function(self, targetType, targetEntity)
        local army = self:GetArmy()
        CreateLightParticle( self, -1, army, 3, 4, 'glow_03', 'ramp_fire_01' ) 
        SingleBeamProjectile.OnImpact(self, targetType, targetEntity)
    end,

--[[
    CheckTarget = function(self)
        while self do
            if not (self:GetTrackingTarget()) then
                #Get New Target
                #LOG("*debug: No Target!!!")
                local unit = self:GetLauncher()
                if unit then
                    local brain = unit:GetAIBrain()
                    #LOG("*debug: Got brain")
                    local units = brain:GetUnitsAroundPoint(categories.AIR, self:GetPosition(),100 , 'Enemy')
                    for k,v in units do
                        #LOG("*debug: Got New Target!")
                        self:SetNewTarget(v)
                        break
                    end
                end
            #else
                #LOG("*debug: Have a target!")
                #LOG("*debug: Target's name is: " ..  self:GetTrackingTarget().GetBlueprint().General.Name)
            end
        WaitSeconds(0.5)
        end
    end,
--]]
}
TypeClass = TIFMissileCruise03

