do

local ADFDisruptorCannonWeapon = import('/lua/aeonweapons.lua').ADFDisruptorWeapon
local OldUnit = DAL0310
DAL0310 = Class(OldUnit) { 

    WeaponROF = 4,
    OnStopBeingBuilt = function(self, builder, layer)
        OldUnit.OnStopBeingBuilt(self, builder, layer)
        self.WeaponDPS = self:GetBlueprint().Weapon[1].DissolverDPS
        self:ForkThread(self.DamageThread)
    end,
    Weapons = {
        MainGun = Class(ADFDisruptorCannonWeapon) {
            OnCreate = function(self)
                self:SetWeaponEnabled(false)
            end,
        }
    },
    DamageThread = function(self) 
        local radius = 25
        while not self:IsDead() do
            WaitSeconds(1 / self.WeaponROF)
            if self.IsBeingTransported == false then
                pos = self:GetPosition() 
                local units = GetUnitsInRect(self:MakeAreaRectangle(pos,radius)) 
                if units then 
                    local army = self:GetArmy() 
                    for k,v in units do 
                        if(army != v:GetArmy()) then 
                            if not EntityCategoryContains(categories.BENIGN, v) then
                                local dist = VDist3(pos,v:GetPosition()) 
                                if dist <= radius then 
                                    Damage(self,v:GetPosition(),v,self.WeaponDPS / self.WeaponROF,'Normal')
                                    if v.AbsolverDamageThread then
                                        KillThread(v.AbsolverDamageThread)
                                    end
                                    v.AbsolverDamageThread = v:ForkThread(v.TakeAbsolverDamage)
                                end 
                            end 
                        end 
                    end 
                end
            end
        end
    end, 

} 

TypeClass = DAL0310

end