do
local OldUnit = UAB1301
UAB1301 = Class(OldUnit) { 
    OnStopBeingBuilt = function(self, builder, layer)
        OldUnit.OnStopBeingBuilt(self, builder, layer) 
        if self:GetCurrentLayer() == 'Seabed' then
            local EconBP = self:GetBlueprint().Economy
            local UnderwaterProductionFactor = EconBP.UnderwaterProductionFactor or 1
            self:SetProductionPerSecondEnergy(EconBP.ProductionPerSecondEnergy * UnderwaterProductionFactor)
        end
    end,
}
TypeClass = UAB1301
end


--[[
do

local OldUnit = UAB1301
local Unit = import('/lua/sim/Unit.lua').Unit
local EffectTemplate = import('/lua/EffectTemplates.lua')
local DefaultUnitsFile = import('/lua/defaultunits.lua')
local EnergyCreationUnit = DefaultUnitsFile.EnergyCreationUnit

UAB1301 = Class(EnergyCreationUnit) { 
    AmbientEffectsBag = {},
    AmbientEffects = 'AT3PowerAmbient',

    OnCreate = function(self)
        EnergyCreationUnit.OnCreate(self)
        self.NumUsedAdjacentUnits = 0
    end,

    OnStopBeingBuilt = function(self, builder, layer)
        EnergyCreationUnit.OnStopBeingBuilt(self, builder, layer)
        --
        local army =  self:GetArmy()
        if self.AmbientEffects then
            for k, v in EffectTemplate[self.AmbientEffects] do
                local fx = CreateAttachedEmitter(self, 0, army, v)
                table.insert(self.AmbientEffectsBag,fx)
            end
        end
        --
        self.Trash:Add(CreateRotator(self, 'Sphere', 'x', nil, 0, 15, 80 + Random(0, 20)))
        self.Trash:Add(CreateRotator(self, 'Sphere', 'y', nil, 0, 15, 80 + Random(0, 20)))
        self.Trash:Add(CreateRotator(self, 'Sphere', 'z', nil, 0, 15, 80 + Random(0, 20)))
        --
        self:SetScriptBit('RULEUTC_CloakToggle', true)
        if self:GetCurrentLayer() == 'Seabed' then
            local EconBP = self:GetBlueprint().Economy
            local UnderwaterProductionFactor = EconBP.UnderwaterProductionFactor or 1
            self:SetProductionPerSecondEnergy(EconBP.ProductionPerSecondEnergy * UnderwaterProductionFactor)
            self:RemoveToggleCap('RULEUTC_CloakToggle')
        end
        self:SetMaintenanceConsumptionInactive()
        self:DisableUnitIntel('Cloak')
        self:RequestRefreshUI()
        self.RecloakCountdown = 0
        self.CloakManagerThread = self:ForkThread(self.CloakManager)
    end,

    Cloak = function(self)
        if not(self:IsIntelEnabled('Cloak')) then 
            self:EnableUnitIntel('Cloak')
            self:DestroyVeteranEmitter()
            if self.EnergySwitch then
                self.EnergySwitch.Cloak = true
                self:UpdateEnergyUsage()
            else
                self:SetMaintenanceConsumptionActive()
            end
            self:SetProductionPerSecondEnergy(0)
            -- Cleanup Visuals
            self:DestroyTarmac()
            for keys,values in self.AmbientEffectsBag do
                values:Destroy()
            end
            self.AmbientEffectsBag = {}
        end
    end,

    Decloak = function(self)
        if self.EnergySwitch then
            self.EnergySwitch.Cloak = false
            self:UpdateEnergyUsage()
        else
            self:SetMaintenanceConsumptionInactive()
        end
        self:SetProductionPerSecondEnergy(self:GetBlueprint().Economy.ProductionPerSecondEnergy)
        if self:IsIntelEnabled('Cloak') then 
            self:DisableUnitIntel('Cloak')
            self:CreateVeteranEmitter()


            -- Re-Create Visuals
            local army =  self:GetArmy()
            if self.AmbientEffects then
                for k, v in EffectTemplate[self.AmbientEffects] do
                    local fx = CreateAttachedEmitter(self, 0, army, v)
                    table.insert(self.AmbientEffectsBag,fx)
                end
            end
            local flatten = self:GetBlueprint().Physics.FlattenSkirt
            if flatten and self:GetCurrentLayer() == 'Land' then
                self:FlattenSkirt(self)
                self:CreateTarmac(true, true, true, false, false)
            end
        end
    end,

    AmbientEffectsBag = {},

    DisableUnitIntel = function(self, intel)
        EnergyCreationUnit.DisableUnitIntel(self, intel)
        if intel then
            if intel == "Cloak" then
                if self.EnergySwitch then
                    self.EnergySwitch.Cloak = false
                    self:UpdateEnergyUsage()
                else
                    self:SetMaintenanceConsumptionInactive()
                end
                self:SetProductionPerSecondEnergy(self:GetBlueprint().Economy.ProductionPerSecondEnergy)
                -- Re-Create Visuals
                local army =  self:GetArmy()
                if self.AmbientEffects then
                    for k, v in EffectTemplate[self.AmbientEffects] do
                        local fx = CreateAttachedEmitter(self, 0, army, v)
                        table.insert(self.AmbientEffectsBag,fx)
                    end
                end
                local flatten = self:GetBlueprint().Physics.FlattenSkirt
                if flatten and self:GetCurrentLayer() == 'Land' then
                    self:FlattenSkirt(self)
                    self:CreateTarmac(true, true, true, false, false)
                end
            end
        end
    end,

    EnableUnitIntel = function(self, intel)
        EnergyCreationUnit.EnableUnitIntel(self, intel)
        if intel then
            if intel == "Cloak" then
                if self.EnergySwitch then
                    self.EnergySwitch.Cloak = true
                    self:UpdateEnergyUsage()
                else
                    self:SetMaintenanceConsumptionActive()
                end
                self:SetProductionPerSecondEnergy(0)
                -- Cleanup Visuals
                self:DestroyTarmac()
                for keys,values in self.AmbientEffectsBag do
                    values:Destroy()
                end
                self.AmbientEffectsBag = {}
            end
        end
    end,

}

TypeClass = UAB1301

end
--]]
