do

local OldUnit = UAB1302 
UAB1302 = Class(OldUnit) 
{ 

    MassYield = 0,
    SpinRate = 1,

    OnStopBeingBuilt = function(self, builder, layer)
        OldUnit.OnStopBeingBuilt(self, builder, layer) 
        self.AgeManagerThread = self:ForkThread(self.AgeManager)
        self.MassYield = self:GetBlueprint().Economy.ProductionPerSecondMass
        self.ExtractionAnimManip:PlayAnim(self:GetBlueprint().Display.AnimationActivate):SetRate(self.SpinRate)
    end,

    AgeManager = function(self)
        while not self:IsDead() and self.MassYield < 30 do
            local aiBrain = self:GetAIBrain()
            local EnergyStorageRatio = aiBrain:GetEconomyStoredRatio('ENERGY')
            if EnergyStorageRatio > 0 then
                self.MassYield = self.MassYield + 0.1
                --LOG("|| MassYield = " .. self.MassYield * (self.MassProdAdjMod or 1))
                self:UpdateProductionValues()
                if self.SpinRate < 8 then
                    self.SpinRate = (self.MassYield / self:GetBlueprint().Economy.ProductionPerSecondMass)
                    self.SpinRate = ((self.SpinRate - 1) * 2) + 1
                end
                if self.SpinRate > 8 then
                    self.SpinRate = 8   -- Set this number to whatever the fastest pumping rate is that doesn't look stupid.
                end
                --LOG("|| SpinRate = " .. self.SpinRate)
            end
            WaitSeconds(7.5)
        end
        self.MassYield = 30
        self:UpdateProductionValues()
    end,

    ActiveState = State {
        Main = function(self)
            WaitFor(self.ExtractionAnimManip)
            while not self:IsDead() do
                self.ExtractionAnimManip:PlayAnim(self:GetBlueprint().Display.AnimationActivate):SetRate(self.SpinRate)
                WaitFor(self.ExtractionAnimManip)
            end
        end,

        OnProductionPaused = function(self)
            OldUnit.OnProductionPaused(self)
            ChangeState(self, self.InActiveState)
        end,
    },

    InActiveState = State {
        Main = function(self)
            WaitFor(self.ExtractionAnimManip)
            if self.ArmsUp == true then
                self.ExtractionAnimManip:SetRate(0 - self.SpinRate)
                WaitFor(self.ExtractionAnimManip)
                self.ArmsUp = false
            end
            WaitFor(self.ExtractionAnimManip)
        end,

        OnProductionUnpaused = function(self)
            OldUnit.OnProductionUnpaused(self)
            ChangeState(self, self.ActiveState)
        end,
    },

} 

TypeClass = UAB1302

end
