do

local AWalkingLandUnit = import('/lua/aeonunits.lua').AWalkingLandUnit
local OldUnit = UAL0301
local function EnhanceThread(self, builder)
    local FactoryEnhancements = builder.EnhanceList or {}
    for k,v in FactoryEnhancements do
        local order = {
            TaskName = "EnhanceTask",
            Enhancement = v
        }
        IssueScript({self}, order)
    end
end
UAL0301 = Class(OldUnit) {
    OnStopBeingBuilt = function(self, builder, layer)
        OldUnit.OnStopBeingBuilt(self, builder, layer)
        self:ForkThread(EnhanceThread, builder)
    end,
    CreateEnhancement = function(self, enh)
        if enh =='ResourceAllocation' then
            -- Do nothing.
        elseif enh == 'ResourceAllocationRemove' then
            -- Do nothing.
        elseif enh == 'Sacrifice' then
            -- Do nothing.
        elseif enh == 'SystemIntegrityCompensator' then
            AWalkingLandUnit.CreateEnhancement(self, enh)
            local bpRegenRate = self:GetBlueprint().Enhancements.SystemIntegrityCompensator.NewRegenRate 
            self.UnitRegenRate = self.UnitRegenRate + bpRegenRate
            if self.TookDamageRecently == false then
                self:SetRegenRate(self.UnitRegenRate + self.UnitBeingRepairedRate)
            end
        elseif enh == 'SystemIntegrityCompensatorRemove' then
            AWalkingLandUnit.CreateEnhancement(self, enh)
            local bpRegenRate = self:GetBlueprint().Enhancements.SystemIntegrityCompensator.NewRegenRate 
            self.UnitRegenRate = self.UnitRegenRate - bpRegenRate
            if self.TookDamageRecently == false then
                self:SetRegenRate(self.UnitRegenRate + self.UnitBeingRepairedRate)
            end
        else
            OldUnit.CreateEnhancement(self,enh)
        end
        self:SetMaxHealth(self:GetMaxHealth() + self:GetBlueprint().Enhancements[enh].ArmorAdjustment) 
        if self:GetBlueprint().Enhancements[enh].ArmorAdjustment > 0 then
            self:SetHealth(self,self:GetHealth() + self:GetBlueprint().Enhancements[enh].ArmorAdjustment)
        else
            if self:GetHealth() > self:GetMaxHealth() then
                self:SetHealth(self,self:GetMaxHealth())
            end
        end
    end,
}   

TypeClass = UAL0301

end
