do

local OldUnit = UAL0401 
UAL0401 = Class(OldUnit) { 

    OnTeleportUnit = function(self, teleporter, location, orientation)
        OldUnit.OnTeleportUnit(self, teleporter, location, orientation)
        self:ForkThread(self.KillWeaponsForTimeout, self) 
    end,

    KillWeaponsForTimeout = function(self)
        self:SetWeaponEnabledByLabel('EyeWeapon', false)
        self:SetWeaponEnabledByLabel('RightArmTractor', false)
        self:SetWeaponEnabledByLabel('LeftArmTractor', false)
        WaitSeconds(30)
        self:SetWeaponEnabledByLabel('EyeWeapon', true)
        self:SetWeaponEnabledByLabel('RightArmTractor', true)
        self:SetWeaponEnabledByLabel('LeftArmTractor', true)
    end,

    DeathThread = function( self, overkillRatio , instigator)
        self:PlayUnitSound('Destroyed')            
        explosion.CreateDefaultHitExplosionAtBone( self, 'Torso', 4.0 )
        explosion.CreateDebrisProjectiles(self, explosion.GetAverageBoundingXYZRadius(self), {self:GetUnitSizes()}) 
        WaitSeconds(0.2)                 
        explosion.CreateDefaultHitExplosionAtBone( self, 'Right_Leg_B02', 1.0 )
        WaitSeconds(0.2)
        explosion.CreateDefaultHitExplosionAtBone( self, 'Right_Leg_B01', 1.0 )
        WaitSeconds(0.1)
        explosion.CreateDefaultHitExplosionAtBone( self, 'Left_Arm_B02', 2.0 )
        WaitSeconds(0.3)
        explosion.CreateDefaultHitExplosionAtBone( self, 'Right_Arm_B01', 1.0 )
                
        WaitSeconds(2.5)
        explosion.CreateDefaultHitExplosionAtBone( self, 'Right_Leg_B02', 1.0 )
        WaitSeconds(0.1)
        explosion.CreateDefaultHitExplosionAtBone( self, 'Right_Leg_B01', 1.0 )
        WaitSeconds(0.1)
        self:PlayUnitSound('Destroyed')
        explosion.CreateDefaultHitExplosionAtBone( self, 'Left_Arm_B02', 3.0 )
        WaitSeconds(0.3)
        self:PlayUnitSound('Destroyed')
        explosion.CreateDefaultHitExplosionAtBone( self, 'Right_Arm_B01', 1.0 )
        explosion.CreateDefaultHitExplosionAtBone( self, 'Right_Leg_B01', 1.0 )
        local bp = self:GetBlueprint()
        for i, numWeapons in bp.Weapon do
            if(bp.Weapon[i].Label == 'CollossusDeath') then
                DamageArea(self, self:GetPosition(), bp.Weapon[i].DamageRadius, bp.Weapon[i].Damage, bp.Weapon[i].DamageType, bp.Weapon[i].DamageFriendly)
                break
            end
        end
        WaitSeconds(2.5)        
        self:PlayUnitSound('Destroyed')
        explosion.CreateDefaultHitExplosionAtBone( self, 'Right_Leg_B02', 2.0 )
        WaitSeconds(0.1)
        explosion.CreateDefaultHitExplosionAtBone( self, 'Right_Leg_B01', 1.0 )
        WaitSeconds(0.1)
        explosion.CreateDefaultHitExplosionAtBone( self, 'Left_Arm_B02', 1.0 )
        WaitSeconds(0.3)
        self:PlayUnitSound('Destroyed')        
        explosion.CreateDefaultHitExplosionAtBone( self, 'Right_Arm_B01', 1.0 )
        explosion.CreateDefaultHitExplosionAtBone( self, 'Right_Leg_B01', 2.0 )
        WaitSeconds(2)
        self:PlayUnitSound('Destroyed')
        explosion.CreateDebrisProjectiles(self, explosion.GetAverageBoundingXYZRadius(self), {self:GetUnitSizes()}) 
        explosion.CreateDefaultHitExplosionAtBone( self, 'Torso', 6.0 )  
        WaitSeconds(0.1)
        self:PlayUnitSound('Destroyed')
        explosion.CreateDebrisProjectiles(self, explosion.GetAverageBoundingXYZRadius(self), {self:GetUnitSizes()}) 
        explosion.CreateDefaultHitExplosionAtBone( self, 'Right_Leg_B02', 4.0 )               

        if self.DeathAnimManip then
            WaitFor(self.DeathAnimManip)
        end

    
        self:DestroyAllDamageEffects()
        self:CreateWreckage( overkillRatio )

        # CURRENTLY DISABLED UNTIL DESTRUCTION
        # Create destruction debris out of the mesh, currently these projectiles look like crap,
        # since projectile rotation and terrain collision doesn't work that great. These are left in
        # hopes that this will look better in the future.. =)
        if( self.ShowUnitDestructionDebris and overkillRatio ) then
            if overkillRatio <= 1 then
                self.CreateUnitDestructionDebris( self, true, true, false )
            elseif overkillRatio <= 2 then
                self.CreateUnitDestructionDebris( self, true, true, false )
            elseif overkillRatio <= 3 then
                self.CreateUnitDestructionDebris( self, true, true, true )
            else #VAPORIZED
                self.CreateUnitDestructionDebris( self, true, true, true )
            end
        end

        self:PlayUnitSound('Destroyed')
        self:Destroy()
    end,
} 

TypeClass = UAL0401

end
