do

local OldUnit = UEB1302 
UEB1302 = Class(OldUnit) 
{ 

    MassYield = 0,
    SpinRate = 1,

    OnStopBeingBuilt = function(self, builder, layer)
        OldUnit.OnStopBeingBuilt(self, builder, layer) 
        self.AgeManagerThread = self:ForkThread(self.AgeManager)
        self.MassYield = self:GetBlueprint().Economy.ProductionPerSecondMass
    end,

    AgeManager = function(self)
        while not self:IsDead() and self.MassYield < 30 do
            local aiBrain = self:GetAIBrain()
            local EnergyStorageRatio = aiBrain:GetEconomyStoredRatio('ENERGY')
            if EnergyStorageRatio > 0 then
                self.MassYield = self.MassYield + 0.1
                --LOG("|| MassYield = " .. self.MassYield * (self.MassProdAdjMod or 1))
                self:UpdateProductionValues()
                if self.SpinRate < 6 then
                    self.SpinRate = (self.MassYield / self:GetBlueprint().Economy.ProductionPerSecondMass)
                    self.SpinRate = ((self.SpinRate - 1) * 1.5) + 1
                end
                if self.SpinRate > 6 then
                    self.SpinRate = 6   -- Set this number to whatever the fastest pumping rate is that doesn't look stupid.
                end
                --LOG("|| SpinRate = " .. self.SpinRate)
                self.AnimationManipulator:SetRate(self.SpinRate)
            end
            WaitSeconds(7.5)
        end
        self.MassYield = 30
        self:UpdateProductionValues()
    end,

    OnProductionUnpaused = function(self)
        TMassCollectionUnit.OnProductionUnpaused(self)
        if not self.AnimationManipulator then return end
        self.AnimationManipulator:SetRate(self.SpinRate)
    end,

} 

TypeClass = UEB1302

end
