
do
local OldUnit = UEL0101
UEL0101 = Class(OldUnit) {
    RadarMode = false,
    InMotion = false,
    DoneBeingBuilt = false,
    CurrentRadar = 0,
    OnStopBeingBuilt = function(self, builder, layer)
        OldUnit.OnStopBeingBuilt(self, builder, layer)
        self:SetScriptBit('RULEUTC_IntelToggle', false) 
        self:SetScriptBit('RULEUTC_SpecialToggle', false) 
        self:AddCommandCap('RULEUCC_Move')
        local bpIntel = self:GetBlueprint().Intel
        self.CurrentRadar = bpIntel.RadarRadius
        self.DoneBeingBuilt = true
    end,
    OnMotionHorzEventChange = function(self, new, old)
        OldUnit.OnMotionHorzEventChange(self, new, old)
        if old == 'Stopped' then
            self:RemoveToggleCap('RULEUTC_SpecialToggle')
        elseif new == 'Stopped' then
            self:AddToggleCap('RULEUTC_SpecialToggle')
        end
    end,
    EnableSpecialToggle = function(self)
        OldUnit.EnableSpecialToggle(self)
        if self.DoneBeingBuilt == true then
            if self.UndeployThread then
                self.UndeployThread:Destroy()
            end
            self:RemoveCommandCap('RULEUCC_Move')
            self:SetImmobile(true)
            self.DeployThread = self:ForkThread(self.Deploy)
        end
    end,
    DisableSpecialToggle = function(self)
        OldUnit.DisableSpecialToggle(self)
        if self.DoneBeingBuilt == true then
            if self.DeployThread then
                self.DeployThread:Destroy()
            end
            self.UndeployThread = self:ForkThread(self.Undeploy)
        end
    end,
    Undeploy = function(self)
        local bpIntel = self:GetBlueprint().Intel
        local MaxRadar = self.CurrentRadar
        local MinRadar = bpIntel.RadarRadius
        local StepSize = 0.25
        local RadarStepSize = (bpIntel.RadarRadiusBoost - bpIntel.RadarRadius) / 20
        while self.CurrentRadar > MinRadar do
            self.CurrentRadar = self.CurrentRadar - RadarStepSize
            self:SetIntelRadius('Radar', self.CurrentRadar)
            WaitSeconds(StepSize)
        end
        self:SetIntelRadius('Radar', MinRadar)
        self:AddCommandCap('RULEUCC_Move')
            self:SetImmobile(false)
    end,
    Deploy = function(self)
        local bpIntel = self:GetBlueprint().Intel
        local MaxRadar = bpIntel.RadarRadiusBoost
        local MinRadar = self.CurrentRadar
        local StepSize = 0.25
        local RadarStepSize = (bpIntel.RadarRadiusBoost - bpIntel.RadarRadius) / 20
        while self.CurrentRadar < MaxRadar do
            self.CurrentRadar = self.CurrentRadar + RadarStepSize
            self:SetIntelRadius('Radar', self.CurrentRadar)
            WaitSeconds(StepSize)
        end
        self:SetIntelRadius('Radar', MaxRadar)
    end,
--[[
    OnScriptBitSet = function(self, bit)
        OldUnit.OnScriptBitSet(self, bit)
        if bit == 3 then # intel toggle
            self.RadarMode = false
        end
    end,
    OnScriptBitClear = function(self, bit)
        OldUnit.OnScriptBitClear(self, bit)
        if bit == 3 then # intel toggle
            self.RadarMode = true
            if self.InMotion == true then
                self:SetScriptBit('RULEUTC_IntelToggle', true) 
                self:SetIntelRadius('Radar', 0)
            end
        end
    end,
    OnMotionHorzEventChange = function(self, new, old)
        OldUnit.OnMotionHorzEventChange(self, new, old)
        if old == 'Stopped' then
            self.InMotion = true
            if self.RadarMode == true then
                self:SetScriptBit('RULEUTC_IntelToggle', true) 
                self:SetIntelRadius('Radar', 0)
                self.RadarMode = true
            end
        elseif new == 'Stopped' then
            self.InMotion = false
            if self.RadarMode == true then
                self:SetScriptBit('RULEUTC_IntelToggle', false) 
                local bpIntel = self:GetBlueprint().Intel
                self:SetIntelRadius('Radar', bpIntel.RadarRadius)
            end
        end
    end,
--]]
}   
TypeClass = UEL0101
end
