do

local TWalkingLandUnit = import('/lua/terranunits.lua').TWalkingLandUnit
local OldUnit = UEL0301
local function EnhanceThread(self, builder)
    local FactoryEnhancements = builder.EnhanceList or {}
    for k,v in FactoryEnhancements do
        local order = {
            TaskName = "EnhanceTask",
            Enhancement = v
        }
        IssueScript({self}, order)
    end
end
UEL0301 = Class(OldUnit) {
    OnStopBeingBuilt = function(self, builder, layer)
        OldUnit.OnStopBeingBuilt(self, builder, layer)
        self:ForkThread(EnhanceThread, builder)
    end,
    CreateEnhancement = function(self, enh)
        if enh =='ResourceAllocation' then
            -- Do nothing.
        elseif enh == 'ResourceAllocationRemove' then
            -- Do nothing.
        elseif enh == 'SensorRangeEnhancer' then
            TWalkingLandUnit.CreateEnhancement(self, enh)
            self:SetIntelRadius('Vision', bp.NewVisionRadius)
            self:SetIntelRadius('Radar', bp.NewRadarRadius)
        elseif enh == 'SensorRangeEnhancerRemove' then
            TWalkingLandUnit.CreateEnhancement(self, enh)
            local bpIntel = self:GetBlueprint().Intel
            self:SetIntelRadius('Vision', bpIntel.VisionRadius)
            self:SetIntelRadius('Radar', 0)
        else
            OldUnit.CreateEnhancement(self,enh)
            if enh == 'ShieldGeneratorField' then
                local bp = self:GetBlueprint().Enhancements[enh]
                self:DestroyShield()
                self:CreatePersonalShield(bp)
            end
        end
        self:SetMaxHealth(self:GetMaxHealth() + self:GetBlueprint().Enhancements[enh].ArmorAdjustment) 
        if self:GetBlueprint().Enhancements[enh].ArmorAdjustment > 0 then
            self:SetHealth(self,self:GetHealth() + self:GetBlueprint().Enhancements[enh].ArmorAdjustment)
        else
            if self:GetHealth() > self:GetMaxHealth() then
                self:SetHealth(self,self:GetMaxHealth())
            end
        end
    end,
}   
    
TypeClass = UEL0301

end
