do

local OldUnit = UES0401 
UES0401 = Class(OldUnit) { 

    SurfaceMode = true,
    Moving = false,
    Built = false,

    OnStopBeingBuilt =function(self, builder, layer)
        OldUnit.OnStopBeingBuilt(self, builder, layer)
        self.Built = true
        self:ManageIntel()
    end,

    OnMotionHorzEventChange = function(self, new, old)
        OldUnit.OnMotionHorzEventChange(self, new, old)
        if old == 'Stopped' then
            self.Moving = true
            self:ManageIntel()
        elseif new == 'Stopped' then
            self.Moving = false
            self:ManageIntel()
        end
    end,

    OnLayerChange = function(self, new, old)
        if old == "Sub" and new == "Water" then                             -- Surfaced
            self.SurfaceMode = true
        end
        if old == "Water" and new == "Sub" then                             -- Submerged
            self.SurfaceMode = false
        end
        self:ManageIntel()
        OldUnit.OnLayerChange(self, new, old)
    end,

    ManageIntel = function(self)
        if self.Built == true then
        local bpIntel = self:GetBlueprint().Intel
        if self.Moving == false and self.SurfaceMode == false then
            self:SetIntelRadius('Vision', bpIntel.VisionRadius)
            self:SetIntelRadius('Sonar', bpIntel.SonarRadius)
            self:SetIntelRadius('Radar', 0)
            self:DisableUnitIntel('Radar')
        elseif self.Moving == false and self.SurfaceMode == true then
            self:SetIntelRadius('Vision', bpIntel.VisionRadius * 1.5)
            self:SetIntelRadius('Sonar', bpIntel.SonarRadius * 0.5)
            self:SetIntelRadius('Radar', bpIntel.RadarRadius)
            self:EnableUnitIntel('Radar')
        elseif self.Moving == true and self.SurfaceMode == false then
            self:SetIntelRadius('Vision', bpIntel.VisionRadius)
            self:SetIntelRadius('Sonar', bpIntel.SonarRadius * .75)
            self:SetIntelRadius('Radar', 0)
            self:DisableUnitIntel('Radar')
        elseif self.Moving == true and self.SurfaceMode == true then
            self:SetIntelRadius('Vision', bpIntel.VisionRadius * 1.5)
            self:SetIntelRadius('Sonar', bpIntel.SonarRadius * 0.25)
            self:SetIntelRadius('Radar', bpIntel.RadarRadius)
            self:EnableUnitIntel('Radar')
        end
        end
    end,

} 

TypeClass = UES0401

end