do
local OldUnit = URB1301
URB1301 = Class(OldUnit) { 
    OnStopBeingBuilt = function(self, builder, layer)
        OldUnit.OnStopBeingBuilt(self, builder, layer) 
        if self:GetCurrentLayer() == 'Seabed' then
            local EconBP = self:GetBlueprint().Economy
            local UnderwaterProductionFactor = EconBP.UnderwaterProductionFactor or 1
            self:SetProductionPerSecondEnergy(EconBP.ProductionPerSecondEnergy * UnderwaterProductionFactor)
        end
    end,
}
TypeClass = URB1301
end


--[[
do

local OldUnit = URB1301
local Unit = import('/lua/sim/Unit.lua').Unit
local EnergyCreationUnit = import('/lua/defaultunits.lua').EnergyCreationUnit
local EffectTemplate = import('/lua/EffectTemplates.lua')

URB1301 = Class(OldUnit) {
    AmbientEffectsBag = {},
    AmbientEffects = 'CT3PowerAmbient',
    OnStopBeingBuilt = function(self, builder, layer)
        EnergyCreationUnit.OnStopBeingBuilt(self, builder, layer)
        --
        local army =  self:GetArmy()
        if self.AmbientEffects then
            for k, v in EffectTemplate[self.AmbientEffects] do
                local fx = CreateAttachedEmitter(self, 0, army, v)
                table.insert(self.AmbientEffectsBag,fx)
            end
        end
        --
        for i = 1, 36 do
            local fxname
            if i < 10 then
                fxname = 'BlinkyLight0' .. i
            else
                fxname = 'BlinkyLight' .. i
            end
            local fx = CreateAttachedEmitter(self, fxname, self:GetArmy(), '/effects/emitters/light_yellow_02_emit.bp'):OffsetEmitter(0, 0, 0.01):ScaleEmitter(1)
            self.Trash:Add(fx)
            table.insert(self.AmbientEffectsBag,fx)
        end
        --
        self:SetScriptBit('RULEUTC_CloakToggle', true)
        if self:GetCurrentLayer() == 'Seabed' then
            local EconBP = self:GetBlueprint().Economy
            local UnderwaterProductionFactor = EconBP.UnderwaterProductionFactor or 1
            self:SetProductionPerSecondEnergy(EconBP.ProductionPerSecondEnergy * UnderwaterProductionFactor)
            self:RemoveToggleCap('RULEUTC_CloakToggle')
        end
        self:SetMaintenanceConsumptionInactive()
        self:DisableUnitIntel('Cloak')
        self:RequestRefreshUI()
        self.RecloakCountdown = 0
        self.CloakManagerThread = self:ForkThread(self.CloakManager)
    end,

    Cloak = function(self)
        if not(self:IsIntelEnabled('Cloak')) then 
            self:EnableUnitIntel('Cloak')
            self:DestroyVeteranEmitter()
            if self.EnergySwitch then
                self.EnergySwitch.Cloak = true
                self:UpdateEnergyUsage()
            else
                self:SetMaintenanceConsumptionActive()
            end
            self:SetProductionPerSecondEnergy(0)
            -- Cleanup Visuals
            self:DestroyTarmac()
            for keys,values in self.AmbientEffectsBag do
                values:Destroy()
            end
            self.AmbientEffectsBag = {}
            LOG("|| Trace 1")
        end
    end,

    Decloak = function(self)
        LOG("|| Trace 2")
        if self.EnergySwitch then
            self.EnergySwitch.Cloak = false
            self:UpdateEnergyUsage()
        else
            self:SetMaintenanceConsumptionInactive()
        end
        self:SetProductionPerSecondEnergy(self:GetBlueprint().Economy.ProductionPerSecondEnergy)
        if self:IsIntelEnabled('Cloak') then 
            LOG("|| Trace 3")
            self:DisableUnitIntel('Cloak')
            self:CreateVeteranEmitter()


            -- Re-Create Visuals
            local army =  self:GetArmy()
            if self.AmbientEffects then
                for k, v in EffectTemplate[self.AmbientEffects] do
                    local fx = CreateAttachedEmitter(self, 0, army, v)
                    table.insert(self.AmbientEffectsBag,fx)
                end
            end
            local flatten = self:GetBlueprint().Physics.FlattenSkirt
            LOG("|| Trace 4")
            if flatten and self:GetCurrentLayer() == 'Land' then
                self:FlattenSkirt(self)
                LOG("|| Trace 5")
                self:CreateTarmac(true, true, true, false, false)
            end
            for i = 1, 36 do
                local fxname
                if i < 10 then
                    fxname = 'BlinkyLight0' .. i
                else
                    fxname = 'BlinkyLight' .. i
                end
                local fx = CreateAttachedEmitter(self, fxname, self:GetArmy(), '/effects/emitters/light_yellow_02_emit.bp'):OffsetEmitter(0, 0, 0.01):ScaleEmitter(1)
                self.Trash:Add(fx)
                table.insert(self.AmbientEffectsBag,fx)
            end
        end
    end,

    AmbientEffectsBag = {},

    DisableUnitIntel = function(self, intel)
        EnergyCreationUnit.DisableUnitIntel(self, intel)
        if intel then
            if intel == "Cloak" then
                if self.EnergySwitch then
                    self.EnergySwitch.Cloak = false
                    self:UpdateEnergyUsage()
                else
                    self:SetMaintenanceConsumptionInactive()
                end
                self:SetProductionPerSecondEnergy(self:GetBlueprint().Economy.ProductionPerSecondEnergy)
                -- Re-Create Visuals
                local army =  self:GetArmy()
                if self.AmbientEffects then
                    for k, v in EffectTemplate[self.AmbientEffects] do
                        local fx = CreateAttachedEmitter(self, 0, army, v)
                        table.insert(self.AmbientEffectsBag,fx)
                    end
                end
                local flatten = self:GetBlueprint().Physics.FlattenSkirt
                LOG("|| Trace 6")
                if flatten and self:GetCurrentLayer() == 'Land' then
                    self:FlattenSkirt(self)
                    LOG("|| Trace 7")
                    self:CreateTarmac(true, true, true, false, false)
                end
                for i = 1, 36 do
                    local fxname
                    if i < 10 then
                        fxname = 'BlinkyLight0' .. i
                    else
                        fxname = 'BlinkyLight' .. i
                    end
                    local fx = CreateAttachedEmitter(self, fxname, self:GetArmy(), '/effects/emitters/light_yellow_02_emit.bp'):OffsetEmitter(0, 0, 0.01):ScaleEmitter(1)
                    self.Trash:Add(fx)
                    table.insert(self.AmbientEffectsBag,fx)
                end
            end
        end
    end,


    EnableUnitIntel = function(self, intel)
        EnergyCreationUnit.EnableUnitIntel(self, intel)
        if intel then
            if intel == "Cloak" then
                LOG("|| Trace 8")
                if self.EnergySwitch then
                    self.EnergySwitch.Cloak = true
                    self:UpdateEnergyUsage()
                else
                    self:SetMaintenanceConsumptionActive()
                end
                self:SetProductionPerSecondEnergy(0)
                -- Cleanup Visuals
                self:DestroyTarmac()
                for keys,values in self.AmbientEffectsBag do
                    values:Destroy()
                end
                self.AmbientEffectsBag = {}
            end
        end
    end,

}

TypeClass = URB1301

end
--]]
