do

local OldUnit = URL0001
URL0001 = Class(OldUnit) {
    CloakDevicePresent = false,

    OnCreate = function(self)
        OldUnit.OnCreate(self)
        self:AddBuildRestriction( categories.CYBRAN * ( categories.BUILTBYTIER1ENGINEER + categories.BUILTBYTIER2COMMANDER + categories.BUILTBYTIER3COMMANDER + categories.EXPERIMENTAL) )
        local cat = ParseEntityCategory('BUILTBYCOMMANDER CYBRAN')
        self:RemoveBuildRestriction(cat)
    end,

    OnStopBeingBuilt = function(self, builder, layer)
        CWalkingLandUnit.OnStopBeingBuilt(self,builder,layer)
        self:SetWeaponEnabledByLabel('RightRipper', true)
        self:SetWeaponEnabledByLabel('Torpedo', false)
        self:SetWeaponEnabledByLabel('MLG', false)
        self:SetWeaponEnabledByLabel('MLG2', false)
        self:SetWeaponEnabledByLabel('MLG3', false)
        self:SetWeaponEnabledByLabel('MLG4', false)
        self.HasNinjaUpgrade = false
        self:HideBone('Back_Upgrade', true)
        self:HideBone('Right_Upgrade', true)
        self:SetScriptBit('RULEUTC_JammingToggle', false)
        self:SetScriptBit('RULEUTC_JammingToggle', true)
        self:RemoveToggleCap('RULEUTC_JammingToggle')
        self:RemoveToggleCap('RULEUTC_CloakToggle')
        self:SetIntelRadius('RadarStealthField', 0)
        self:RequestRefreshUI()
        self:ForkThread(self.GiveInitialResources)
    end,
    Weapons = {
        DeathWeapon = Class(CIFCommanderDeathWeapon) {},
        RightRipper = Class(CCannonMolecularWeapon) {
            OnWeaponFired = function(self)
                local bp = self:GetBlueprint()
                if self.unit.HasNinjaUpgrade and self.unit.HasNinjaUpgrade == true then
                    if self.unit.RecloakCountdown < (bp.UpgradedRecloakAfterFiringDelay or 0) then
                        self.unit.RecloakCountdown = bp.UpgradedRecloakAfterFiringDelay or 0
                    end
                else
                    if self.unit.RecloakCountdown < (bp.RecloakAfterFiringDelay or 0) then
                        self.unit.RecloakCountdown = bp.RecloakAfterFiringDelay or 0
                    end
                end
                CCannonMolecularWeapon.OnWeaponFired(self)
            end,
        },
        Torpedo = Class(CANTorpedoLauncherWeapon) {},
        MLG = Class(CDFHeavyMicrowaveLaserGeneratorCom) {
            OnWeaponFired = function(self)
                local bp = self:GetBlueprint()
                if self.unit.HasNinjaUpgrade and self.unit.HasNinjaUpgrade == true then
                    if self.unit.RecloakCountdown < (bp.UpgradedRecloakAfterFiringDelay or 0) then
                        self.unit.RecloakCountdown = bp.UpgradedRecloakAfterFiringDelay or 0
                    end
                else
                    if self.unit.RecloakCountdown < (bp.RecloakAfterFiringDelay or 0) then
                        self.unit.RecloakCountdown = bp.RecloakAfterFiringDelay or 0
                    end
                end
                CDFHeavyMicrowaveLaserGeneratorCom.OnWeaponFired(self)
            end,
        },
        MLG2 = Class(CDFHeavyMicrowaveLaserGeneratorCom) {
            OnWeaponFired = function(self)
                local bp = self:GetBlueprint()
                if self.unit.HasNinjaUpgrade and self.unit.HasNinjaUpgrade == true then
                    if self.unit.RecloakCountdown < (bp.UpgradedRecloakAfterFiringDelay or 0) then
                        self.unit.RecloakCountdown = bp.UpgradedRecloakAfterFiringDelay or 0
                    end
                else
                    if self.unit.RecloakCountdown < (bp.RecloakAfterFiringDelay or 0) then
                        self.unit.RecloakCountdown = bp.RecloakAfterFiringDelay or 0
                    end
                end
                CDFHeavyMicrowaveLaserGeneratorCom.OnWeaponFired(self)
            end,
        },
        MLG3 = Class(CDFHeavyMicrowaveLaserGeneratorCom) {
            OnWeaponFired = function(self)
                local bp = self:GetBlueprint()
                if self.unit.HasNinjaUpgrade and self.unit.HasNinjaUpgrade == true then
                    if self.unit.RecloakCountdown < (bp.UpgradedRecloakAfterFiringDelay or 0) then
                        self.unit.RecloakCountdown = bp.UpgradedRecloakAfterFiringDelay or 0
                    end
                else
                    if self.unit.RecloakCountdown < (bp.RecloakAfterFiringDelay or 0) then
                        self.unit.RecloakCountdown = bp.RecloakAfterFiringDelay or 0
                    end
                end
                CDFHeavyMicrowaveLaserGeneratorCom.OnWeaponFired(self)
            end,
        },
        MLG4 = Class(CDFHeavyMicrowaveLaserGeneratorCom) {
            OnWeaponFired = function(self)
                local bp = self:GetBlueprint()
                if self.unit.HasNinjaUpgrade and self.unit.HasNinjaUpgrade == true then
                    if self.unit.RecloakCountdown < (bp.UpgradedRecloakAfterFiringDelay or 0) then
                        self.unit.RecloakCountdown = bp.UpgradedRecloakAfterFiringDelay or 0
                    end
                else
                    if self.unit.RecloakCountdown < (bp.RecloakAfterFiringDelay or 0) then
                        self.unit.RecloakCountdown = bp.RecloakAfterFiringDelay or 0
                    end
                end
                CDFHeavyMicrowaveLaserGeneratorCom.OnWeaponFired(self)
            end,
        },

        OverCharge = Class(CDFOverchargeWeapon) {
            OnCreate = function(self)
                CDFOverchargeWeapon.OnCreate(self)
                self:SetWeaponEnabled(false)
                self.AimControl:SetEnabled(false)
                self.AimControl:SetPrecedence(0)
            end,

            OnEnableWeapon = function(self)
                CDFOverchargeWeapon.OnEnableWeapon(self)
                self:SetWeaponEnabled(true)
                self.unit:SetWeaponEnabledByLabel('RightRipper', false)
                self.unit:BuildManipulatorSetEnabled(false)
                self.AimControl:SetEnabled(true)
                self.AimControl:SetPrecedence(20)
                self.unit.BuildArmManipulator:SetPrecedence(0)
                self.AimControl:SetHeadingPitch( self.unit:GetWeaponManipulatorByLabel('RightRipper'):GetHeadingPitch() )
            end,

            OnGotTarget = function(self)
                CDFOverchargeWeapon.OnGotTarget(self)
            end,

            OnWeaponFired = function(self)
                CDFOverchargeWeapon.OnWeaponFired(self)
                self:SetWeaponEnabled(false)
                self.unit:SetWeaponEnabledByLabel('RightRipper', true)
                self.unit:BuildManipulatorSetEnabled(false)
                self.AimControl:SetEnabled(false)
                self.AimControl:SetPrecedence(0)
                self.unit.BuildArmManipulator:SetPrecedence(0)
                self.unit:GetWeaponManipulatorByLabel('RightRipper'):SetHeadingPitch( self.AimControl:GetHeadingPitch() )

                local bp = self:GetBlueprint()
                if self.unit.HasNinjaUpgrade and self.unit.HasNinjaUpgrade == true then
                    if self.unit.RecloakCountdown < (bp.UpgradedRecloakAfterFiringDelay or 0) then
                        self.unit.RecloakCountdown = bp.UpgradedRecloakAfterFiringDelay or 0
                    end
                else
                    if self.unit.RecloakCountdown < (bp.RecloakAfterFiringDelay or 0) then
                        self.unit.RecloakCountdown = bp.RecloakAfterFiringDelay or 0
                    end
                end
            end,
            
            OnDisableWeapon = function(self)
                self:SetWeaponEnabled(false)
                self.unit:SetWeaponEnabledByLabel('RightRipper', true)
                self.unit:BuildManipulatorSetEnabled(false)
                self.AimControl:SetEnabled(false)
                self.AimControl:SetPrecedence(0)
                self.unit.BuildArmManipulator:SetPrecedence(0)
                self.unit:GetWeaponManipulatorByLabel('RightRipper'):SetHeadingPitch( self.AimControl:GetHeadingPitch() )
            end,
        },
    },
    CreateEnhancement = function(self, enh)
        CWalkingLandUnit.CreateEnhancement(self, enh)
        if enh =='ResourceAllocation' then
            -- Do nothing.
        elseif enh == 'ResourceAllocationRemove' then
            -- Do nothing.
        elseif enh =='CoolingUpgrade' then
            -- Do nothing.
        elseif enh == 'CoolingUpgradeRemove' then
            -- Do nothing.

        --                                                         
        --                        BACK                             
        --                                                         

        elseif enh == 'StealthGenerator' then 
            self:AddToggleCap('RULEUTC_JammingToggle')
            self:SetIntelRadius('RadarStealthField', 25)
            self:SetScriptBit('RULEUTC_JammingToggle', true)
            self:SetScriptBit('RULEUTC_JammingToggle', false)
            self:RequestRefreshUI()
        elseif enh == 'StealthGeneratorRemove' then
            self:SetScriptBit('RULEUTC_JammingToggle', true)
            self:SetIntelRadius('RadarStealthField', 0)
            self:RemoveToggleCap('RULEUTC_JammingToggle')
            self:RequestRefreshUI()
        elseif enh == 'DamageSponge' then
            self.DamageSponge = true
            self:SetRegenRate(500)
        elseif enh == 'DamageSpongeRemove' then
            self.DamageSponge = false
            self:SetRegenRate(self:GetBlueprint().Defense.RegenRate)
            self:SetScriptBit('RULEUTC_JammingToggle', true)
            self:SetIntelRadius('RadarStealthField', 0)
            self:RemoveToggleCap('RULEUTC_JammingToggle')
            self:RequestRefreshUI()
        elseif enh == 'CloakingGenerator' or enh == 'CloakingGenerator2'then
            self:AddToggleCap('RULEUTC_CloakToggle')
            self:SetScriptBit('RULEUTC_CloakToggle', true)
            self:SetScriptBit('RULEUTC_CloakToggle', false)
            self:RequestRefreshUI()
            self.RecloakCountdown = 0
            self.CloakManagerThread = self:ForkThread(self.CloakManager)
            self.CloakDevicePresent = true
        elseif enh == 'CloakingGeneratorRemove' or enh == 'CloakingGenerator2Remove' then
            self:SetScriptBit('RULEUTC_CloakToggle', true)
            self:RemoveToggleCap('RULEUTC_CloakToggle')
            if self.CloakManagerThread then
                self.CloakManagerThread:Destroy()
            end
            self.CloakDevicePresent = false
            self.DamageSponge = false
            self:SetRegenRate(self:GetBlueprint().Defense.RegenRate)
            self:SetScriptBit('RULEUTC_JammingToggle', true)
            self:SetIntelRadius('RadarStealthField', 0)
            self:RemoveToggleCap('RULEUTC_JammingToggle')
            self:RequestRefreshUI()
        elseif enh == 'NinjaCloak' then
            self.HasNinjaUpgrade = true
            self.EnergyUsageRates.CloakWhileMoving = 0
            self.EnergyUsageRates.Cloak = 0
            self.EnergyUsageRates.CounterIntel = 0
            self:UpdateEnergyUsage()
            self.bpDecloakRadius = 0
            self.bpDecloakRadiusWhileMoving = 0
            self.bpCloakDisableAfterNoEnergyTimer = 0
        elseif enh == 'NinjaCloakRemove' then
            self.HasNinjaUpgrade = false
            local bp = self:GetBlueprint()
            local bpEnergy = bp.Economy.EnergyUsageRates
            self.EnergyUsageRates.CloakWhileMoving = bpEnergy.CloakWhileMoving
            self.EnergyUsageRates.Cloak = bpEnergy.Cloak
            self.EnergyUsageRates.CounterIntel = bpEnergy.CounterIntel
            self:UpdateEnergyUsage()
            self.bpDecloakRadius = bp.Intel.DecloakRadius
            self.bpDecloakRadiusWhileMoving = bp.Intel.DecloakRadiusWhileMoving
            self.bpCloakDisableAfterNoEnergyTimer = bp.Intel.CloakDisableAfterNoEnergyTimer
            self:SetScriptBit('RULEUTC_CloakToggle', true)
            self:RemoveToggleCap('RULEUTC_CloakToggle')
            if self.CloakManagerThread then
                self.CloakManagerThread:Destroy()
            end
            self.CloakDevicePresent = false
            self.DamageSponge = false
            self:SetRegenRate(self:GetBlueprint().Defense.RegenRate)
            self:SetScriptBit('RULEUTC_JammingToggle', true)
            self:SetIntelRadius('RadarStealthField', 0)
            self:RemoveToggleCap('RULEUTC_JammingToggle')
            self:RequestRefreshUI()
        elseif enh == 'Teleporter' then
            self.HasTeleportUpgrade = true
            self.InBeaconProximityTesting = false
            self.TeleportRechargeTime = 15
            self.TeleportEnergyCost = 3000
        elseif enh == 'TeleporterRemove' then
            self.HasTeleportUpgrade = false
            self.InBeaconProximityTesting = false
            self:RemoveCommandCap('RULEUCC_Teleport')
            self.TeleportRechargeTime = 60
            self.TeleportEnergyCost = 15000

        --                                                         
        --                      LEFT ARM                           
        --                                                         

        elseif enh =='Nanolathe' then
            local cat = ParseEntityCategory('BUILTBYTIER1ENGINEER CYBRAN')
            self:RemoveBuildRestriction(cat)
            local bp = self:GetBlueprint().Enhancements[enh]
            self:SetBuildRateOverride(bp.NewBuildRate)
        elseif enh =='NanolatheRemove' then
            self:AddBuildRestriction( categories.CYBRAN * ( categories.BUILTBYTIER1ENGINEER + categories.BUILTBYTIER2COMMANDER + categories.BUILTBYTIER3COMMANDER + categories.EXPERIMENTAL + categories.DECOY) )
            local cat = ParseEntityCategory('BUILTBYCOMMANDER CYBRAN')
            self:RemoveBuildRestriction(cat)
            self:SetBuildRateOverride(nil)
        elseif enh =='AdvancedEngineering' then
            local bp = self:GetBlueprint().Enhancements[enh]
            local cat = ParseEntityCategory(bp.BuildableCategoryAdds)
            self:RemoveBuildRestriction(cat)
            self:SetBuildRateOverride(bp.NewBuildRate)
        elseif enh =='AdvancedEngineeringRemove' then
            local bp = self:GetBlueprint().Enhancements[enh]
            self:SetBuildRateOverride(nil)
            self:RestoreBuildRestrictions()
            self:AddBuildRestriction( categories.CYBRAN * ( categories.BUILTBYTIER1ENGINEER + categories.BUILTBYTIER2COMMANDER + categories.BUILTBYTIER3COMMANDER + categories.EXPERIMENTAL + categories.DECOY) )
            local cat = ParseEntityCategory('BUILTBYCOMMANDER CYBRAN')
            self:RemoveBuildRestriction(cat)
        elseif enh =='T3Engineering' then
            local bp = self:GetBlueprint().Enhancements[enh]
            if not bp then return end
            local cat = ParseEntityCategory(bp.BuildableCategoryAdds)
            self:RemoveBuildRestriction(cat)
            self:SetBuildRateOverride(bp.NewBuildRate)
        elseif enh =='T3EngineeringRemove' then
            local bp = self:GetBlueprint().Economy.BuildRate
            if not bp then return end
            self:SetBuildRateOverride(nil)
            self:RestoreBuildRestrictions()
            self:AddBuildRestriction( categories.CYBRAN * ( categories.BUILTBYTIER1ENGINEER + categories.BUILTBYTIER2COMMANDER + categories.BUILTBYTIER3COMMANDER + categories.EXPERIMENTAL + categories.DECOY) )
            local cat = ParseEntityCategory('BUILTBYCOMMANDER CYBRAN')
            self:RemoveBuildRestriction(cat)
        elseif enh =='T4Engineering' then
            local bp = self:GetBlueprint().Enhancements[enh]
            if not bp then return end
            local cat = ParseEntityCategory(bp.BuildableCategoryAdds)
            self:RemoveBuildRestriction(cat)
            self:SetBuildRateOverride(bp.NewBuildRate)
        elseif enh =='T4EngineeringRemove' then
            local bp = self:GetBlueprint().Economy.BuildRate
            if not bp then return end
            self:SetBuildRateOverride(nil)
            self:RestoreBuildRestrictions()
            self:AddBuildRestriction( categories.CYBRAN * ( categories.BUILTBYTIER1ENGINEER + categories.BUILTBYTIER2COMMANDER + categories.BUILTBYTIER3COMMANDER + categories.EXPERIMENTAL + categories.DECOY) )
            local cat = ParseEntityCategory('BUILTBYCOMMANDER CYBRAN')
            self:RemoveBuildRestriction(cat)

        --                                                         
        --                     RIGHT ARM                           
        --                                                         

        elseif enh == 'MicrowaveLaserGenerator' then
            self:SetWeaponEnabledByLabel('MLG', true)
            local wep = self:GetWeaponByLabel('RightRipper')
            wep:ChangeMinRadius(12.1)
        elseif enh == 'MicrowaveLaserGeneratorRemove' then
            self:SetWeaponEnabledByLabel('MLG', false)
            local wep = self:GetWeaponByLabel('RightRipper')
            wep:ChangeMinRadius(2)
        elseif enh =='WeaponEnhanceLevel2' then
            self:SetWeaponEnabledByLabel('MLG', false)

            self:SetWeaponEnabledByLabel('MLG2', true)
            local wep = self:GetWeaponByLabel('MLG2')
            wep:ChangeMaxRadius(19)

            local wep2 = self:GetWeaponByLabel('RightRipper')
            wep2:ChangeMinRadius(19.1)
        elseif enh =='WeaponEnhanceLevel2Remove' then
            self:SetWeaponEnabledByLabel('MLG2', false)

            local wep2 = self:GetWeaponByLabel('RightRipper')
            wep2:ChangeMinRadius(2)
        elseif enh =='WeaponEnhanceLevel3' then
            self:SetWeaponEnabledByLabel('MLG2', false)

            self:SetWeaponEnabledByLabel('MLG3', true)
            local wep = self:GetWeaponByLabel('MLG3')
            wep:ChangeMaxRadius(27)

            self:SetWeaponEnabledByLabel('RightRipper', false)
        elseif enh =='WeaponEnhanceLevel3Remove' then
            self:SetWeaponEnabledByLabel('MLG3', false)
            local wep = self:GetWeaponByLabel('MLG3')
            wep:ChangeMaxRadius(1)

            self:SetWeaponEnabledByLabel('RightRipper', true)
            local wep2 = self:GetWeaponByLabel('RightRipper')
            wep2:ChangeMinRadius(2)
        elseif enh =='WeaponEnhanceLevel4' then
            self:SetWeaponEnabledByLabel('MLG3', false)
            local wep = self:GetWeaponByLabel('MLG3')
            wep:ChangeMaxRadius(1)

            self:SetWeaponEnabledByLabel('MLG4', true)
            local wep2 = self:GetWeaponByLabel('MLG4')
            wep2:ChangeMaxRadius(35)
        elseif enh =='WeaponEnhanceLevel4Remove' then
            self:SetWeaponEnabledByLabel('MLG4', false)
            local wep = self:GetWeaponByLabel('MLG4')
            wep:ChangeMaxRadius(1)

            self:SetWeaponEnabledByLabel('RightRipper', true)
            local wep2 = self:GetWeaponByLabel('RightRipper')
            wep2:ChangeMinRadius(2)
        elseif enh == 'NaniteTorpedoTube' then
            self:SetWeaponEnabledByLabel('Torpedo', true)
        elseif enh == 'NaniteTorpedoTubeRemove' then
            self:SetWeaponEnabledByLabel('Torpedo', false)
        end
    end,
    OnKilled = function(self, instigator, type, overkillRatio)
        CWalkingLandUnit.OnKilled(self, instigator, type, overkillRatio)
    end,
    OnMotionHorzEventChange = function( self, new, old )
        OldUnit.OnMotionHorzEventChange(self, new, old)
        if self.CloakDevicePresent == true then
            if old == 'Stopped' then
                self:UpdateEnergyUsage()
            end
            if new == 'Stopped' then
                self:UpdateEnergyUsage()
            end
        end
    end,
}

TypeClass = URL0001

end
