local HoverLandUnit = import('/lua/defaultunits.lua').HoverLandUnit

SAB5000 = Class(HoverLandUnit) {
    
    OnStopBeingBuilt = function(self, builder, layer)
        HoverLandUnit.OnStopBeingBuilt(self, builder, layer)
        #B04 = parent, B03 = ball, B01/2 = rings
        #CreateRotator(unit, bone, axis, [goal], [speed], [accel], [goalspeed])
        self.Trash:Add(CreateRotator(self, 'Shell01', 'x', nil, 0, 60, 40 + Random(0, 20) * self:GetRandomDir()))
        #self.Trash:Add(CreateRotator(self, 'Shell01', 'y', nil, 0, 5, 20 + Random(0, 20) * self:GetRandomDir()))
        self.Trash:Add(CreateRotator(self, 'Shell01', 'z', nil, 0, 60, 80 + Random(0, 20) * self:GetRandomDir()))

        self.Trash:Add(CreateRotator(self, 'Shell02', 'x', nil, 0, 60, 120 + Random(0, 20) * self:GetRandomDir()))
        self.Trash:Add(CreateRotator(self, 'Shell02', 'y', nil, 0, 60, 40 + Random(0, 20) * self:GetRandomDir()))
        #self.Trash:Add(CreateRotator(self, 'Shell02', 'z', nil, 0, 25, 80 + Random(0, 20) * self:GetRandomDir()))

        #self.Trash:Add(CreateRotator(self, 'Orbs', 'x', nil, 0, 15, 80 + Random(0, 20) * self:GetRandomDir()))
        self.Trash:Add(CreateRotator(self, 'Orbs', 'y', nil, 0, 15, 80 + Random(0, 5) * self:GetRandomDir()))
        #self.Trash:Add(CreateRotator(self, 'Orbs', 'z', nil, 0, 15, 0 + Random(0, 20) * self:GetRandomDir()))

        self:SetScriptBit('RULEUTC_IntelToggle', false)
        self:SetMaintenanceConsumptionActive()
        self.TeleportBeaconActive = true
        self:ForkThread(self.WatchThread) 
    end,

    GetRandomDir = function(self)
        local num = Random(0, 2)
        if num > 1 then
            return 1
        end
        return -1
    end,
   
    WatchThread = function(self) 
        while true and not self:IsDead() do 
            local aiBrain = self:GetAIBrain() 
            local EnergyStorageRatio = aiBrain:GetEconomyStoredRatio('ENERGY')
            if EnergyStorageRatio == 0 or self.TeleportBeaconIsBeingTransported == true then
                if self:GetScriptBit('RULEUTC_IntelToggle') == false then
                    self.TeleportBeaconActive = false
                    self:SetMaintenanceConsumptionInactive()
                end
            else
                if self:GetScriptBit('RULEUTC_IntelToggle') == false then
                    self.TeleportBeaconActive = true
                    self:SetMaintenanceConsumptionActive()
                end
            end
            self:ProcessLocalUnits()
            WaitSeconds(1) 
        end 
    end, 

    ProcessLocalUnits = function(self)
        local UnitsInRange = self:GetUnitsInSphere()
        for k,v in UnitsInRange do 
            if EntityCategoryContains(categories.MOBILE,v) then
                if v.IsTeleportBeacon == false then
                    if v.NaturalTeleporter == false then
                        if v.BeaconProximityThread == nil then
                            v.BeaconProximityThread = v:ForkThread(v.TestBeaconProximity,v)
                        end
                    end
                end
            end
        end
    end,

    OnScriptBitSet = function(self, bit)
        HoverLandUnit.OnScriptBitSet(self, bit) 
        if bit == 3 then # intel toggle
            self.TeleportBeaconActive = false
        end
    end,

    OnScriptBitClear = function(self, bit)
        HoverLandUnit.OnScriptBitClear(self, bit) 
        if bit == 3 then # intel toggle
            self.TeleportBeaconActive = true
        end
    end,

    GetUnitsInSphere = function(self)
        local position = self:GetPosition()
        local radius = self.TeleportBeaconDetectionRadius
        local x1 = position.x - radius
        local y1 = position.y - radius
        local z1 = position.z - radius
        local x2 = position.x + radius
        local y2 = position.y + radius
        local z2 = position.z + radius
        local units = GetUnitsInRect( Rect(x1, z1, x2, z2) )
        #Check for empty rectangle
        if not units then
            return UnitsinRec
        end
        local Results = {}
        for k, v in units do
            if(self:GetArmy() == v:GetArmy()) then 
                local dist = self:Get2DDistance(position,v:GetPosition()) 
                if dist <= radius then 
                    table.insert(Results, v)
                end
            end
        end
        return Results
    end

}

TypeClass = SAB5000